"use strict";
/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// import * as tfliteWebAPIClient from '../tflite_web_api_client';
var common_1 = require("./common");
/** The transformer for the TFJS MobileNet model. */
exports.TFJSMobileNetTransformer = {
    load: function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var loadedMobilenet, mobilenetModel;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, common_1.loadPackages('mobilenet', [
                            ['https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-core@3.1.0'],
                            [
                                'https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-converter@3.1.0',
                                'https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-webgl@3.1.0'
                            ],
                            ['https://cdn.jsdelivr.net/npm/@tensorflow-models/mobilenet@2.1.0'],
                        ])];
                    case 1:
                        loadedMobilenet = _a.sent();
                        return [4 /*yield*/, loadedMobilenet.load(config)];
                    case 2:
                        mobilenetModel = _a.sent();
                        // Transform to ImageClassifier task model.
                        return [2 /*return*/, {
                                classify: function (img, options) { return __awaiter(_this, void 0, void 0, function () {
                                    var mobilenetResults, classes, finalResult;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, mobilenetModel.classify(img, options ? options.topK : undefined)];
                                            case 1:
                                                mobilenetResults = _a.sent();
                                                classes = mobilenetResults.map(function (result) {
                                                    return {
                                                        className: result.className,
                                                        probability: result.probability,
                                                    };
                                                });
                                                finalResult = {
                                                    classes: classes,
                                                };
                                                return [2 /*return*/, finalResult];
                                        }
                                    });
                                }); },
                                cleanUp: function () { },
                            }];
                }
            });
        });
    }
};
// /** The transformer for the TFLite MobileNet model. */
// export const TFLiteMobileNetTransformer:
//     TaskModelLoader<ImageClassifier, TFLiteMobileNetOptions> = {
//       async load(options?: TFLiteMobileNetOptions):
//       Promise<ImageClassifier> {
//         let modelName = '';
//         const version = `${((options && options.version) || 1).toFixed(2)}`;
//         const alpha = `${((options && options.alpha) || 1.0).toFixed(2)}`;
//         if (version === '1.00') {
//           if (alpha === '0.25') {
//             modelName = 'mobilenet_v1_0.25_224_1_metadata_1.tflite';
//           } else if (alpha === '0.50') {
//             modelName = 'mobilenet_v1_0.50_224_1_metadata_1.tflite';
//           } else if (alpha === '0.75') {
//             modelName = 'mobilenet_v1_0.75_224_1_metadata_1.tflite';
//           } else if (alpha === '1.00') {
//             modelName = 'mobilenet_v1_1.0_224_1_metadata_1.tflite';
//           }
//         } else if (version === '2.00') {
//           if (alpha === '1.00') {
//             modelName = 'mobilenet_v2_1.0_224_1_metadata_1.tflite';
//           } else {
//             modelName = 'mobilenet_v1_1.0_224_1_metadata_1.tflite';
//             console.warn(`WARNING: MobileNet v${version}_${
//                 alpha} not supported. Use the default one instead: ${
//                 modelName}`);
//           }
//         }
//         // TODO: use tfhub url instead when it is ready.
//         const modelUrl =
//             `https://storage.googleapis.com/tfweb/models/${modelName}`;
//         return transformTFLiteImageClassifierModel(modelUrl, options);
//       }
//     };
// /** The transformer for the TFLite image classifier with custom model url. */
// export const TFLiteImageClassifierTransformer: TaskModelLoader<
//     ImageClassifier, TFLiteImageClassificationCustomModelOptions> = {
//   async load(options?: TFLiteImageClassificationCustomModelOptions):
//       Promise<ImageClassifier> {
//         if (!options) {
//           throw new Error('Must provide options with modelUrl specified');
//         }
//         return transformTFLiteImageClassifierModel(options.modelUrl,
//         options);
//       }
// };
// async function transformTFLiteImageClassifierModel(
//     modelUrl: string,
//     options?: TFLiteImageClassificationBaseOptions):
//     Promise<ImageClassifier> {
//   // Load the model.
//   const tfwebOptions = new tfliteWebAPIClient.tfweb.ImageClassifierOptions();
//   if (options) {
//     if (options.maxResults !== undefined) {
//       tfwebOptions.setMaxResults(options.maxResults);
//     }
//     if (options.numThreads !== undefined) {
//       tfwebOptions.setNumThreads(options.numThreads);
//     }
//     if (options.scoreThreshold !== undefined) {
//       tfwebOptions.setScoreThreshold(options.scoreThreshold);
//     }
//   }
//   const tfwebImageClassifier =
//       await tfliteWebAPIClient.tfweb.ImageClassifier.create(
//           modelUrl, tfwebOptions);
//   // Transform to ImageClassifier task model.
//   const imageClassifier: ImageClassifier = {
//     classify: async (img) => {
//       const tfwebResults = tfwebImageClassifier.classify(img);
//       const classes: Class[] = [];
//       const tfwebClassificationsList = tfwebResults.getClassificationsList();
//       if (tfwebClassificationsList.length > 0) {
//         tfwebClassificationsList[0].getClassesList().forEach(cls => {
//           classes.push({
//             className: cls.getDisplayName() || cls.getClassName(),
//             probability: cls.getScore(),
//           });
//         });
//       }
//       const finalResult: ImageClassifierResult = {
//         classes,
//       };
//       return finalResult;
//     },
//     cleanUp: () => {
//       tfwebImageClassifier.cleanUp();
//     },
//   };
//   return imageClassifier;
// }
//# sourceMappingURL=image_classification.js.map