/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import * as tflite from '@tensorflow/tfjs-tflite';
import { QuestionAnswerer, QuestionAnswerResult } from './common';
/**
 * The base class for all Q&A TFLite models.
 *
 * @template T The type of inference options.
 */
export declare class QuestionAnswererTFLite<T> extends QuestionAnswerer<T> {
    private tfliteQuestionAnswerer;
    constructor(tfliteQuestionAnswerer: tflite.BertQuestionAnswerer);
    predict(question: string, context: string, infereceOptions?: T): Promise<QuestionAnswerResult>;
    cleanUp(): void;
}
