/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.tfTask = {}));
}(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Whether the current environment is in web worker or not. */
    function isWebWorker() {
        return typeof window === 'undefined';
    }

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * A loader for dynamically loading a set of packages (with dependencies) and
     * returning the global namespace variable initialized by those packages.
     *
     * @template G The type of the global namespace variable.
     */
    var PackageLoader = /** @class */ (function () {
        function PackageLoader() {
        }
        /**
         * Loads the given packages and returns the loaded global namespace.
         *
         * See `TaskModelLoader.packageUrls` for more info about how to use it to
         * specify packages with dependencies.
         *
         * TODO: use a design similar to tfjs' `Platform` to provide different
         * implmentations for dynamic package loading, global, etc.
         */
        PackageLoader.prototype.loadPackagesAndGetGlobalNamespace = function (namespace, packageUrls, curIndex) {
            if (curIndex === void 0) { curIndex = 0; }
            return __awaiter(this, void 0, void 0, function () {
                var global_1, globalNamespace;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (curIndex >= packageUrls.length) {
                                global_1 = isWebWorker() ? self : window;
                                globalNamespace = global_1[namespace];
                                if (!globalNamespace) {
                                    throw new Error("Global namespace '" + namespace + "' not set after loading packages " + packageUrls);
                                }
                                return [2 /*return*/, globalNamespace];
                            }
                            return [4 /*yield*/, Promise.all(packageUrls[curIndex].map(function (name) { return _this.loadPackage(name); }))];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.loadPackagesAndGetGlobalNamespace(namespace, packageUrls, curIndex + 1)];
                        case 2: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        PackageLoader.prototype.loadPackage = function (packageUrl) {
            return __awaiter(this, void 0, void 0, function () {
                var script_1, promise;
                return __generator(this, function (_a) {
                    // Don't load a package if the package is being loaded or has already been
                    // loaded.
                    if (PackageLoader.promises[packageUrl]) {
                        return [2 /*return*/, PackageLoader.promises[packageUrl]];
                    }
                    // From webworker.
                    if (isWebWorker()) {
                        importScripts(packageUrl);
                        PackageLoader.promises[packageUrl] = Promise.resolve();
                    }
                    // From webpage.
                    else {
                        script_1 = document.createElement('script');
                        script_1.crossOrigin = 'anonymous';
                        promise = new Promise(function (resolve, reject) {
                            script_1.onerror = function () {
                                reject();
                                document.head.removeChild(script_1);
                            };
                            script_1.onload = function () {
                                resolve();
                            };
                        });
                        document.head.appendChild(script_1);
                        script_1.setAttribute('src', packageUrl);
                        PackageLoader.promises[packageUrl] = promise;
                    }
                    return [2 /*return*/, PackageLoader.promises[packageUrl]];
                });
            });
        };
        PackageLoader.promises = {};
        return PackageLoader;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Default TFJS backend. */
    var DEFAULT_TFJS_BACKEND = 'webgl';
    /** Default TFJS version. */
    var DEFAULT_TFJS_VERSION = '3.6.0';
    /** All supported tasks. */
    var Task;
    (function (Task) {
        Task["IMAGE_CLASSIFICATION"] = "IMAGE_CLASSIFICATION";
        Task["OBJECT_DETECTION"] = "OBJECT_DETECTION";
        Task["IMAGE_SEGMENTATION"] = "IMAGE_SEGMENTATION";
        Task["SENTIMENT_DETECTION"] = "SENTIMENT_DETECTION";
        Task["NL_CLASSIFICATION"] = "NL_CLASSIFICATION";
        Task["QUESTION_AND_ANSWER"] = "QUESTION_AND_ANSWER";
    })(Task || (Task = {}));
    /** All supported runtimes. */
    var Runtime;
    (function (Runtime) {
        Runtime["TFJS"] = "TFJS";
        Runtime["TFLITE"] = "TFLite";
        Runtime["MEDIA_PIPE"] = "MediaPipe";
    })(Runtime || (Runtime = {}));
    /** A helper function to get the TFJS packages that a TFJS model depends on. */
    function getTFJSModelDependencyPackages(backend, version) {
        if (backend === void 0) { backend = DEFAULT_TFJS_BACKEND; }
        if (version === void 0) { version = DEFAULT_TFJS_VERSION; }
        var packages = [
            ["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-core@" + version],
            ["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-converter@" + version],
        ];
        switch (backend) {
            case 'cpu':
                packages[1].push("https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@" + version);
                break;
            case 'webgl':
                packages[1].push("https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@" + version);
                packages[1].push("https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-webgl@" + version);
                break;
            case 'wasm':
                packages[1].push("https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-wasm@" + version + "/dist/tf-backend-wasm.min.js");
                break;
        }
        return packages;
    }
    /**
     * Makes sure the current tfjs backend matches the one in the given option.
     *
     * For TFJS models, this function should be called at the loading time as well
     * as before running inference.
     *
     * Users might run multiple TFJS models with different backend options in a web
     * app. Only setting the backend at the model loading time is not enough because
     * the backend might be set to another one when loading a different model. We
     * also need to call this right before running the inference.
     */
    function ensureTFJSBackend(options) {
        return __awaiter(this, void 0, void 0, function () {
            var backend, global, tf;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        backend = options ? options.backend : DEFAULT_TFJS_BACKEND;
                        global = isWebWorker() ? self : window;
                        tf = global['tf'];
                        if (!tf) {
                            throw new Error('tfjs not loaded');
                        }
                        if (!(tf.getBackend() !== backend)) return [3 /*break*/, 2];
                        return [4 /*yield*/, tf.setBackend(backend)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    }

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * A loader that loads a task model.
     *
     * A task model is backed by a "source model" that does the actual work, so the
     * main task of a model loader is to load this source model and "transform" it
     * into the target task model. To do that, the client that implements the
     * `TaskModelLoader` needs to:
     *
     * - Provide a set of metadata, such as model name, runtime, etc.
     *
     * - Provide package urls and global namespace name for the source model.
     *   `TaskModelLoader` will load the packages, and return the global namespace
     *   variable provided by the source model.
     *
     * - Implement the `transformSourceModel` method to load the source model using
     *   the global namespace variable from the previous step, and transform the
     *   source model to the corresponding task model.
     *
     *   To make this process more structured, each task will have a more concrete
     *   interface of `TaskModel` with the task-specific method defined. All the
     *   models under the task will transform to this interface to make sure they
     *   have the same API signature. See tasks/image_classification/common.ts for
     *   an example.
     *
     * @template N The type of the global namespace provided by the source model.
     * @template LO The type of options used during the model loading process.
     * @template M The type of the target task model to transform to.
     */
    var TaskModelLoader = /** @class */ (function () {
        function TaskModelLoader() {
            /**
             * Callback to wait for (await) after all packages are loaded.
             *
             * This is necessary for models where certain conditions need to be met before
             * using the model.
             */
            this.postPackageLoadingCallback = undefined;
            /** A loader for loading packages. */
            this.packageLoader = new PackageLoader();
        }
        /**
         * Loads the task model with the given options.
         *
         * @param options Options to use when loading the model.
         * @returns The loaded instance.
         */
        TaskModelLoader.prototype.load = function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var sourceModelGlobal;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.loadSourceModelGlobalNamespace(options)];
                        case 1:
                            sourceModelGlobal = _a.sent();
                            if (!this.postPackageLoadingCallback) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.postPackageLoadingCallback()];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            if (!(this.metadata.runtime === Runtime.TFJS)) return [3 /*break*/, 5];
                            return [4 /*yield*/, ensureTFJSBackend(options)];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5: 
                        // Load the source model using the global namespace variable loaded above.
                        return [2 /*return*/, this.transformSourceModel(sourceModelGlobal, options)];
                    }
                });
            });
        };
        /**
         * Loads the global namespace of the source model by loading its packages
         * specified in the `packageUrls` field above.
         *
         * It is typically not necessary for subclasses to override this method as
         * long as they set the `packageUrls` and `sourceModelGlobalNamespace` field
         * above.
         */
        TaskModelLoader.prototype.loadSourceModelGlobalNamespace = function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var packages, tfjsOptions;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            packages = [];
                            // Add TFJS dependencies for TFJS models.
                            if (this.metadata.runtime === Runtime.TFJS) {
                                tfjsOptions = options;
                                packages.push.apply(packages, getTFJSModelDependencyPackages(tfjsOptions ? tfjsOptions.backend : undefined));
                            }
                            // Load packages.
                            packages.push.apply(packages, this.packageUrls);
                            return [4 /*yield*/, this.packageLoader.loadPackagesAndGetGlobalNamespace(this.sourceModelGlobalNamespace, packages)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * Loads the source model and transforms it to the corresponding task model.
         *
         * A subclass should implement this method and use the
         * `sourceModelGlobalNamespace` to load the source model. Note that the
         * subclass should *NOT* use the namespace from the import statement to
         * implement this method (e.g. the "mobilenet" variable in `import * as
         * mobilenet from
         * '@tensorflow-models/mobilenet`). Instead, only `sourceModelGlobalNamespace`
         * should be used, which should have the same type as the imported namespace.
         * The imported namespace can only be used to reference types. This makes sure
         * that the code from the source model is NOT bundled in the final binary.
         */
        TaskModelLoader.prototype.transformSourceModel = function (sourceModelGlobalNamespace, options) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    throw new Error('not implemented');
                });
            });
        };
        return TaskModelLoader;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all ImageClassification task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'Image Classification', subheading: 'Base model'}
     */
    var ImageClassifier = /** @class */ (function () {
        function ImageClassifier() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'Image Classification', subheading: 'Base model'}
         */
        ImageClassifier.prototype.cleanUp = function () { };
        return ImageClassifier;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all image classification TFLite models.
     *
     * @template T The type of inference options.
     */
    var ImageClassifierTFLite = /** @class */ (function (_super) {
        __extends(ImageClassifierTFLite, _super);
        function ImageClassifierTFLite(tfliteImageClassifier) {
            var _this = _super.call(this) || this;
            _this.tfliteImageClassifier = tfliteImageClassifier;
            return _this;
        }
        ImageClassifierTFLite.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, classes, finalResult;
                return __generator(this, function (_a) {
                    if (!this.tfliteImageClassifier) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteImageClassifier.classify(img);
                    if (!tfliteResults) {
                        return [2 /*return*/, { classes: [] }];
                    }
                    classes = tfliteResults.map(function (result) {
                        return {
                            className: result.className,
                            score: result.probability,
                        };
                    });
                    finalResult = { classes: classes };
                    return [2 /*return*/, finalResult];
                });
            });
        };
        ImageClassifierTFLite.prototype.cleanUp = function () {
            if (!this.tfliteImageClassifier) {
                throw new Error('source model is not loaded');
            }
            this.tfliteImageClassifier.cleanUp();
        };
        return ImageClassifierTFLite;
    }(ImageClassifier));

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for custom image classification TFLite model. */
    var ImageClassificationCustomModelTFLiteLoader = /** @class */ (function (_super) {
        __extends(ImageClassificationCustomModelTFLiteLoader, _super);
        function ImageClassificationCustomModelTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'Image classification with TFLite models',
                description: 'An image classfier backed by the TFLite Task Library. ' +
                    'It can work with any models that meet the ' +
                    '<a href="https://www.tensorflow.org/lite/inference_with_metadata/' +
                    'task_library/image_classifier#model_compatibility_requirements" ' +
                    'target:"_blank">model requirements</a>. Try models from this ' +
                    '<a href="https://tfhub.dev/tensorflow/collections/lite/task-library/' +
                    'image-classifier/1" target="_blank">collection</a>.',
                resourceUrls: {
                    'TFLite task library': 'https://www.tensorflow.org/lite/' +
                        'inference_with_metadata/task_library/overview',
                },
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.IMAGE_CLASSIFICATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        ImageClassificationCustomModelTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteImageClassifier;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.ImageClassifier.create(loadingOptions.model, loadingOptions)];
                        case 1:
                            tfliteImageClassifier = _a.sent();
                            return [2 /*return*/, new ICCustomModelTFLite(tfliteImageClassifier)];
                    }
                });
            });
        };
        return ImageClassificationCustomModelTFLiteLoader;
    }(TaskModelLoader));
    /**
     * A custom TFLite image classification model loaded from a model url or
     * an `ArrayBuffer` in memory.
     *
     * The underlying image classifier is built on top of the [TFLite Task
     * Library](https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview).
     * As a result, the custom model needs to meet the [metadata
     * requirements](https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_classifier#model_compatibility_requirements).
     *
     * Usage:
     *
     * ```js
     * // Load the model from a custom url with other options (optional).
     * const model = await tfTask.ImageClassification.CustomModel.TFLite.load({
     *   model:
     * 'https://tfhub.dev/google/lite-model/aiy/vision/classifier/plants_V1/3',
     * });
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result.classes);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageClassifier` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'ICCustomModelTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'ICCustomModelTFLiteInferenceOptions'}
     * ]
     *
     *
     * @doc {heading: 'Image Classification', subheading: 'Models'}
     */
    var ICCustomModelTFLite = /** @class */ (function (_super) {
        __extends(ICCustomModelTFLite, _super);
        function ICCustomModelTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ICCustomModelTFLite;
    }(ImageClassifierTFLite));
    var imageClassificationCustomModelTfliteLoader = new ImageClassificationCustomModelTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for mobilenet TFJS model. */
    var MobilenetTFJSLoader = /** @class */ (function (_super) {
        __extends(MobilenetTFJSLoader, _super);
        function MobilenetTFJSLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFJS Mobilenet',
                description: 'Run mobilenet image classification model with TFJS',
                resourceUrls: {
                    'github': 'https://github.com/tensorflow/tfjs-models/tree/master/mobilenet',
                },
                runtime: Runtime.TFJS,
                version: '2.1.0',
                supportedTasks: [Task.IMAGE_CLASSIFICATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow-models/mobilenet@" + _this.metadata.version]];
            _this.sourceModelGlobalNamespace = 'mobilenet';
            return _this;
        }
        MobilenetTFJSLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var mobilenetModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.load(loadingOptions)];
                        case 1:
                            mobilenetModel = _a.sent();
                            return [2 /*return*/, new MobilenetTFJS(mobilenetModel, loadingOptions)];
                    }
                });
            });
        };
        return MobilenetTFJSLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFJS mobilenet model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * //
     * // By default, it uses mobilenet V1 with webgl backend. You can change them
     * // in the options parameter of the `load` function (see below for docs).
     * const model = await tfTask.ImageClassification.Mobilenet.TFJS.load();
     *
     * // Run inference on an image with options (optional).
     * const img = document.querySelector('img');
     * const result = await model.predict(img, {topK: 5});
     * console.log(result.classes);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageClassifier` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol: 'MobilenetTFJSLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'MobilenetTFJSInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Image Classification', subheading: 'Models'}
     */
    var MobilenetTFJS = /** @class */ (function (_super) {
        __extends(MobilenetTFJS, _super);
        function MobilenetTFJS(mobilenetModel, loadingOptions) {
            var _this = _super.call(this) || this;
            _this.mobilenetModel = mobilenetModel;
            _this.loadingOptions = loadingOptions;
            return _this;
        }
        MobilenetTFJS.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var mobilenetResults, classes, finalResult;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.mobilenetModel) {
                                throw new Error('source model is not loaded');
                            }
                            return [4 /*yield*/, ensureTFJSBackend(this.loadingOptions)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.mobilenetModel.classify(img, infereceOptions ? infereceOptions.topK : undefined)];
                        case 2:
                            mobilenetResults = _a.sent();
                            classes = mobilenetResults.map(function (result) {
                                return {
                                    className: result.className,
                                    score: result.probability,
                                };
                            });
                            finalResult = {
                                classes: classes,
                            };
                            return [2 /*return*/, finalResult];
                    }
                });
            });
        };
        return MobilenetTFJS;
    }(ImageClassifier));
    var mobilenetTfjsLoader = new MobilenetTFJSLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for mobilenet TFLite model. */
    var MobilenetTFLiteLoader = /** @class */ (function (_super) {
        __extends(MobilenetTFLiteLoader, _super);
        function MobilenetTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFLite Mobilenet',
                description: 'Run mobilenet image classification model with TFLite',
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.IMAGE_CLASSIFICATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        MobilenetTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var mobilenetVersion, mobilenetAlpha, url, tfliteImageClassifier;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            mobilenetVersion = '1';
                            mobilenetAlpha = '1.0';
                            if (loadingOptions) {
                                if (loadingOptions.version !== undefined) {
                                    mobilenetVersion = String(loadingOptions.version);
                                }
                                if (loadingOptions.alpha !== undefined) {
                                    mobilenetAlpha = String(loadingOptions.alpha);
                                }
                            }
                            // There is no TFLite mobilenet v2 model available other than 2_1.0.
                            if (mobilenetVersion === '2' && mobilenetAlpha !== '1.0') {
                                mobilenetAlpha = '1.0';
                                console.warn("No mobilenet TFLite model available for " + mobilenetVersion + "_" + mobilenetAlpha + ". Using 2_1.0 instead.");
                            }
                            url = "https://storage.googleapis.com/tfweb/models/mobilenet_v" + mobilenetVersion + "_" + mobilenetAlpha + "_224_1_metadata_1.tflite";
                            return [4 /*yield*/, sourceModelGlobal.ImageClassifier.create(url, loadingOptions)];
                        case 1:
                            tfliteImageClassifier = _a.sent();
                            return [2 /*return*/, new MobilenetTFLite(tfliteImageClassifier)];
                    }
                });
            });
        };
        return MobilenetTFLiteLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFLite mobilenet image classification model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * //
     * // By default, it uses mobilenet V1. You can change it in the options
     * // parameter of the `load` function (see below for docs).
     * const model = await tfTask.ImageClassification.Mobilenet.TFJS.load();
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result.classes);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageClassifier` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'MobilenetTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`',
     * symbol: 'MobilenetTFLiteInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Image Classification', subheading: 'Models'}
     */
    var MobilenetTFLite = /** @class */ (function (_super) {
        __extends(MobilenetTFLite, _super);
        function MobilenetTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return MobilenetTFLite;
    }(ImageClassifierTFLite));
    var mobilenetTfliteLoader = new MobilenetTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all ImageSegmentation task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'Image Segmentation', subheading: 'Base model'}
     */
    var ImageSegmenter = /** @class */ (function () {
        function ImageSegmenter() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'Image Segmentation', subheading: 'Base model'}
         */
        ImageSegmenter.prototype.cleanUp = function () { };
        return ImageSegmenter;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all image segmentation TFLite models.
     *
     * @template T The type of inference options.
     */
    var ImageSegmenterTFLite = /** @class */ (function (_super) {
        __extends(ImageSegmenterTFLite, _super);
        function ImageSegmenterTFLite(tfliteImageSegmenter) {
            var _this = _super.call(this) || this;
            _this.tfliteImageSegmenter = tfliteImageSegmenter;
            return _this;
        }
        ImageSegmenterTFLite.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, segmentation, legend, colors, _i, _a, coloredLabel, segmentationMap, i, categoryIndex, color;
                return __generator(this, function (_b) {
                    if (!this.tfliteImageSegmenter) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteImageSegmenter.segment(img);
                    if (!tfliteResults) {
                        return [2 /*return*/, {
                                legend: {},
                                width: -1,
                                height: -1,
                                segmentationMap: undefined,
                            }];
                    }
                    segmentation = tfliteResults[0];
                    legend = {};
                    colors = [];
                    for (_i = 0, _a = segmentation.coloredLabels; _i < _a.length; _i++) {
                        coloredLabel = _a[_i];
                        legend[coloredLabel.className || coloredLabel.displayName] = coloredLabel;
                        colors.push(coloredLabel);
                    }
                    segmentationMap = new Uint8ClampedArray(segmentation.width * segmentation.height * 4);
                    for (i = 0; i < segmentation.categoryMask.length; i++) {
                        categoryIndex = segmentation.categoryMask[i];
                        color = colors[categoryIndex];
                        segmentationMap[i * 4] = color.r;
                        segmentationMap[i * 4 + 1] = color.g;
                        segmentationMap[i * 4 + 2] = color.b;
                        segmentationMap[i * 4 + 3] = 255;
                    }
                    return [2 /*return*/, {
                            legend: legend,
                            width: segmentation.width,
                            height: segmentation.height,
                            segmentationMap: segmentationMap,
                        }];
                });
            });
        };
        ImageSegmenterTFLite.prototype.cleanUp = function () {
            if (!this.tfliteImageSegmenter) {
                throw new Error('source model is not loaded');
            }
            this.tfliteImageSegmenter.cleanUp();
        };
        return ImageSegmenterTFLite;
    }(ImageSegmenter));

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for custom image segmentation TFLite model. */
    var ImageSegmentationCustomModelTFLiteLoader = /** @class */ (function (_super) {
        __extends(ImageSegmentationCustomModelTFLiteLoader, _super);
        function ImageSegmentationCustomModelTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'Image segmentation with TFLite models',
                description: 'An image segmentation backed by the TFLite Task Library. ' +
                    'It can work with any models that meet the ' +
                    '<a href="https://www.tensorflow.org/lite/inference_with_metadata/' +
                    'task_library/image_segmenter#model_compatibility_requirements" ' +
                    'target="_blank">model requirements</a>.Try models from this ' +
                    '<a href="https://tfhub.dev/tensorflow/collections/lite/task-library/' +
                    'image-segmenter/1" target="_blank">collection</a>.',
                resourceUrls: {
                    'TFLite task library': 'https://www.tensorflow.org/lite/' +
                        'inference_with_metadata/task_library/overview',
                },
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.IMAGE_SEGMENTATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        ImageSegmentationCustomModelTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteImageSegmenter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.ImageSegmenter.create(loadingOptions.model, loadingOptions)];
                        case 1:
                            tfliteImageSegmenter = _a.sent();
                            return [2 /*return*/, new ISCustomModelTFLite(tfliteImageSegmenter)];
                    }
                });
            });
        };
        return ImageSegmentationCustomModelTFLiteLoader;
    }(TaskModelLoader));
    /**
     * A custom TFLite image segmentation model loaded from a model url or an
     * `ArrayBuffer` in memory.
     *
     * The underlying image segmenter is built on top of the [TFLite Task
     * Library](https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview).
     * As a result, the custom model needs to meet the [metadata
     * requirements](https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_segmenter#model_compatibility_requirements).
     *
     * Usage:
     *
     * ```js
     * // Load the model from a custom url with other options (optional).
     * const model = await tfTask.ImageSemgentation.CustomModel.TFLite.load({
     *   model:
     * 'https://tfhub.dev/tensorflow/lite-model/deeplabv3/1/metadata/2?lite-format=tflite',
     * });
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageSegmenter` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'ISCustomModelTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'ISCustomModelTFLiteInferenceOptions'}
     * ]
     *
     *
     * @doc {heading: 'Image Segmentation', subheading: 'Models'}
     */
    var ISCustomModelTFLite = /** @class */ (function (_super) {
        __extends(ISCustomModelTFLite, _super);
        function ISCustomModelTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ISCustomModelTFLite;
    }(ImageSegmenterTFLite));
    var imageSegmenterCustomModelTfliteLoader = new ImageSegmentationCustomModelTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for deeplab TFJS model. */
    var DeeplapTFJSLoader = /** @class */ (function (_super) {
        __extends(DeeplapTFJSLoader, _super);
        function DeeplapTFJSLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFJS Deeplab',
                description: 'Run deeplab image segmentation model with TFJS',
                resourceUrls: {
                    'github': 'https://github.com/tensorflow/tfjs-models/tree/master/deeplab',
                },
                runtime: Runtime.TFJS,
                version: '0.2.1',
                supportedTasks: [Task.IMAGE_SEGMENTATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow-models/deeplab@" + _this.metadata.version]];
            _this.sourceModelGlobalNamespace = 'deeplab';
            return _this;
        }
        DeeplapTFJSLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var options, deeplabModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            options = __assign({}, loadingOptions) ||
                                { backend: 'webgl' };
                            if (options.base == null) {
                                options.base = 'pascal';
                            }
                            if (options.quantizationBytes == null) {
                                options.quantizationBytes = 2;
                            }
                            return [4 /*yield*/, sourceModelGlobal.load(options)];
                        case 1:
                            deeplabModel = _a.sent();
                            return [2 /*return*/, new DeeplabTFJS(deeplabModel, options)];
                    }
                });
            });
        };
        return DeeplapTFJSLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFJS depelab model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * //
     * // By default, it uses base='pascal' and quantizationBytes=2 with webgl
     * // backend. You can change them in the options parameter of the `load`
     * // function (see below for docs).
     * const model = await tfTask.ImageSegmentation.Deeplab.TFJS.load();
     *
     * // Run inference on an image with options (optional).
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageSegmenter` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol: 'DeeplabTFJSLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'DeeplabTFJSInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Image Segmentation', subheading: 'Models'}
     */
    var DeeplabTFJS = /** @class */ (function (_super) {
        __extends(DeeplabTFJS, _super);
        function DeeplabTFJS(deeplabModel, loadingOptions) {
            var _this = _super.call(this) || this;
            _this.deeplabModel = deeplabModel;
            _this.loadingOptions = loadingOptions;
            return _this;
        }
        DeeplabTFJS.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var deeplabResult, legend, _i, _a, name_1, colors;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!this.deeplabModel) {
                                throw new Error('source model is not loaded');
                            }
                            return [4 /*yield*/, ensureTFJSBackend(this.loadingOptions)];
                        case 1:
                            _b.sent();
                            return [4 /*yield*/, this.deeplabModel.segment(img, infereceOptions)];
                        case 2:
                            deeplabResult = _b.sent();
                            legend = {};
                            for (_i = 0, _a = Object.keys(deeplabResult.legend); _i < _a.length; _i++) {
                                name_1 = _a[_i];
                                colors = deeplabResult.legend[name_1];
                                legend[name_1] = {
                                    r: colors[0],
                                    g: colors[1],
                                    b: colors[2],
                                };
                            }
                            return [2 /*return*/, {
                                    legend: legend,
                                    width: deeplabResult.width,
                                    height: deeplabResult.height,
                                    segmentationMap: deeplabResult.segmentationMap,
                                }];
                    }
                });
            });
        };
        DeeplabTFJS.prototype.cleanUp = function () {
            if (!this.deeplabModel) {
                throw new Error('source model is not loaded');
            }
            this.deeplabModel.dispose();
        };
        return DeeplabTFJS;
    }(ImageSegmenter));
    var deeplabTfjsLoader = new DeeplapTFJSLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for deeplab TFLite model. */
    var DeeplabTFLiteLoader = /** @class */ (function (_super) {
        __extends(DeeplabTFLiteLoader, _super);
        function DeeplabTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFLite Deeplab',
                description: 'Run Deeplab image segmentation model with TFLite',
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.IMAGE_SEGMENTATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        DeeplabTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var url, tfliteImageSegmenter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://tfhub.dev/tensorflow/lite-model/' +
                                'deeplabv3/1/metadata/2?lite-format=tflite';
                            return [4 /*yield*/, sourceModelGlobal.ImageSegmenter.create(url, loadingOptions)];
                        case 1:
                            tfliteImageSegmenter = _a.sent();
                            return [2 /*return*/, new DeeplabTFLite(tfliteImageSegmenter)];
                    }
                });
            });
        };
        return DeeplabTFLiteLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFLite deeplab image segmentation model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * const model = await tfTask.ImageSegmentation.Deeplab.TFLite.load();
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ImageSegmenter` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'DeeplabTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`',
     * symbol: 'DeeplabTFLiteInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Image Segmentation', subheading: 'Models'}
     */
    var DeeplabTFLite = /** @class */ (function (_super) {
        __extends(DeeplabTFLite, _super);
        function DeeplabTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return DeeplabTFLite;
    }(ImageSegmenterTFLite));
    var deeplabTfliteLoader = new DeeplabTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all NLClassification task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'NL Classification', subheading: 'Base model'}
     */
    var NLClassifier = /** @class */ (function () {
        function NLClassifier() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'NL Classification', subheading: 'Base model'}
         */
        NLClassifier.prototype.cleanUp = function () { };
        return NLClassifier;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all NL classification TFLite models.
     *
     * @template T The type of inference options.
     */
    var NLClassifierTFLite = /** @class */ (function (_super) {
        __extends(NLClassifierTFLite, _super);
        function NLClassifierTFLite(tfliteNLClassifier) {
            var _this = _super.call(this) || this;
            _this.tfliteNLClassifier = tfliteNLClassifier;
            return _this;
        }
        NLClassifierTFLite.prototype.predict = function (text, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, classes, finalResult;
                return __generator(this, function (_a) {
                    if (!this.tfliteNLClassifier) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteNLClassifier.classify(text);
                    if (!tfliteResults) {
                        return [2 /*return*/, { classes: [] }];
                    }
                    classes = tfliteResults.map(function (result) {
                        return {
                            className: result.className,
                            score: result.probability,
                        };
                    });
                    finalResult = { classes: classes };
                    return [2 /*return*/, finalResult];
                });
            });
        };
        NLClassifierTFLite.prototype.cleanUp = function () {
            if (!this.tfliteNLClassifier) {
                throw new Error('source model is not loaded');
            }
            this.tfliteNLClassifier.cleanUp();
        };
        return NLClassifierTFLite;
    }(NLClassifier));
    /** Merges the given options with the default NLClassifier options. */
    function getNLClassifierOptions(options) {
        var nlclassifierOptions = {
            inputTensorIndex: 0,
            outputScoreTensorIndex: 0,
            outputLabelTensorIndex: -1,
            inputTensorName: 'INPUT',
            outputScoreTensorName: 'OUTPUT_SCORE',
            outputLabelTensorName: 'OUTPUT_LABEL',
        };
        if (!options) {
            return nlclassifierOptions;
        }
        if (options.inputTensorIndex != null) {
            nlclassifierOptions.inputTensorIndex = options.inputTensorIndex;
        }
        if (options.outputScoreTensorIndex != null) {
            nlclassifierOptions.outputScoreTensorIndex = options.outputScoreTensorIndex;
        }
        if (options.outputLabelTensorIndex != null) {
            nlclassifierOptions.outputLabelTensorIndex = options.outputLabelTensorIndex;
        }
        if (options.inputTensorName != null) {
            nlclassifierOptions.inputTensorName = options.inputTensorName;
        }
        if (options.outputScoreTensorName != null) {
            nlclassifierOptions.outputScoreTensorName = options.outputScoreTensorName;
        }
        if (options.outputLabelTensorName != null) {
            nlclassifierOptions.outputLabelTensorName = options.outputLabelTensorName;
        }
        return nlclassifierOptions;
    }

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for custom nl classification TFLite model. */
    var NLClassificationCustomModelTFLiteLoader = /** @class */ (function (_super) {
        __extends(NLClassificationCustomModelTFLiteLoader, _super);
        function NLClassificationCustomModelTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'Natural language classification with TFLite models',
                description: 'A natural language detector backed by the NLClassifier in ' +
                    'TFLite Task Library. ' +
                    'It can work with any models that meet the ' +
                    '<a href="https://www.tensorflow.org/lite/inference_with_metadata/' +
                    'task_library/nl_classifier#model_compatibility_requirements" ' +
                    'target="_blank">model requirements</a>.',
                resourceUrls: {
                    'TFLite task library': 'https://www.tensorflow.org/lite/' +
                        'inference_with_metadata/task_library/overview',
                },
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.NL_CLASSIFICATION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        NLClassificationCustomModelTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteNLClassifier;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.NLClassifier.create(loadingOptions.model, getNLClassifierOptions(loadingOptions))];
                        case 1:
                            tfliteNLClassifier = _a.sent();
                            return [2 /*return*/, new NCCustomModelTFLite(tfliteNLClassifier)];
                    }
                });
            });
        };
        return NLClassificationCustomModelTFLiteLoader;
    }(TaskModelLoader));
    /**
     * A custom TFLite natural language classification model loaded from a model url
     * or an `ArrayBuffer` in memory.
     *
     * The underlying NL classifier is built on top of the NLClassifier in
     * [TFLite Task
     * Library](https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview).
     * As a result, the custom model needs to meet the [metadata
     * requirements](https://www.tensorflow.org/lite/inference_with_metadata/task_library/nl_classifier#model_compatibility_requirements).
     *
     * Usage:
     *
     * ```js
     * // Load the model from a custom url with other options (optional).
     * const model = await tfTask.NLClassification.CustomModel.TFLite.load({
     *   model:
     * 'https://storage.googleapis.com/download.tensorflow.org/models/tflite/text_classification/text_classification_v2.tflite',
     * });
     *
     * // Run inference on text.
     * const result = await model.predict('This is a great movie!');
     * console.log(result.classes);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.NLClassifier` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'NCCustomModelTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'NCCustomModelTFLiteInferenceOptions'}
     * ]
     *
     *
     * @doc {heading: 'NL Classification', subheading: 'Models'}
     */
    var NCCustomModelTFLite = /** @class */ (function (_super) {
        __extends(NCCustomModelTFLite, _super);
        function NCCustomModelTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NCCustomModelTFLite;
    }(NLClassifierTFLite));
    var nlClassifierCustomModelTfliteLoader = new NLClassificationCustomModelTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all ObjectDetection task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'Object Detection', subheading: 'Base model'}
     */
    var ObjectDetector = /** @class */ (function () {
        function ObjectDetector() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'Object Detection', subheading: 'Base model'}
         */
        ObjectDetector.prototype.cleanUp = function () { };
        return ObjectDetector;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for cocossd TFJS model. */
    var CocoSsdTFJSLoader = /** @class */ (function (_super) {
        __extends(CocoSsdTFJSLoader, _super);
        function CocoSsdTFJSLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFJS COCO-SSD',
                description: 'Run COCO-SSD object detection model with TFJS',
                resourceUrls: {
                    'github': 'https://github.com/tensorflow/tfjs-models/tree/master/coco-ssd',
                },
                runtime: Runtime.TFJS,
                version: '2.2.2',
                supportedTasks: [Task.OBJECT_DETECTION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow-models/coco-ssd@" + _this.metadata.version]];
            _this.sourceModelGlobalNamespace = 'cocoSsd';
            return _this;
        }
        CocoSsdTFJSLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var cocoSsdModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.load(loadingOptions)];
                        case 1:
                            cocoSsdModel = _a.sent();
                            return [2 /*return*/, new CocoSsdTFJS(cocoSsdModel, loadingOptions)];
                    }
                });
            });
        };
        return CocoSsdTFJSLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFJS coco-ssd model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * //
     * // By default, it uses lite_mobilenet_v2 as the base model with webgl
     * // backend. You can change them in the `options` parameter of the `load`
     * // function (see below for docs).
     * const model = await tfTask.ObjectDetection.CocoSsd.TFJS.load();
     *
     * // Run detection on an image with options (optional).
     * const img = document.querySelector('img');
     * const result = await model.predict(img, {numMaxBoxes: 5});
     * console.log(result.objects);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ObjectDetector` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol: 'CocoSsdTFJSLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'CocoSsdTFJSInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Object Detection', subheading: 'Models'}
     */
    var CocoSsdTFJS = /** @class */ (function (_super) {
        __extends(CocoSsdTFJS, _super);
        function CocoSsdTFJS(cocoSsdModel, loadingOptions) {
            var _this = _super.call(this) || this;
            _this.cocoSsdModel = cocoSsdModel;
            _this.loadingOptions = loadingOptions;
            return _this;
        }
        CocoSsdTFJS.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var cocoSsdResults, objects, finalResult;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.cocoSsdModel) {
                                throw new Error('source model is not loaded');
                            }
                            return [4 /*yield*/, ensureTFJSBackend(this.loadingOptions)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.cocoSsdModel.detect(img, infereceOptions ? infereceOptions.maxNumBoxes : undefined, infereceOptions ? infereceOptions.minScore : undefined)];
                        case 2:
                            cocoSsdResults = _a.sent();
                            objects = cocoSsdResults.map(function (result) {
                                return {
                                    boundingBox: {
                                        originX: result.bbox[0],
                                        originY: result.bbox[1],
                                        width: result.bbox[2],
                                        height: result.bbox[3],
                                    },
                                    className: result.class,
                                    score: result.score,
                                };
                            });
                            finalResult = {
                                objects: objects,
                            };
                            return [2 /*return*/, finalResult];
                    }
                });
            });
        };
        CocoSsdTFJS.prototype.cleanUp = function () {
            if (!this.cocoSsdModel) {
                throw new Error('source model is not loaded');
            }
            return this.cocoSsdModel.dispose();
        };
        return CocoSsdTFJS;
    }(ObjectDetector));
    var cocoSsdTfjsLoader = new CocoSsdTFJSLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all object detection TFLite models.
     *
     * @template T The type of inference options.
     */
    var ObjectDetectorTFLite = /** @class */ (function (_super) {
        __extends(ObjectDetectorTFLite, _super);
        function ObjectDetectorTFLite(tfliteObjectDetector) {
            var _this = _super.call(this) || this;
            _this.tfliteObjectDetector = tfliteObjectDetector;
            return _this;
        }
        ObjectDetectorTFLite.prototype.predict = function (img, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, objects, finalResult;
                return __generator(this, function (_a) {
                    if (!this.tfliteObjectDetector) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteObjectDetector.detect(img);
                    if (!tfliteResults) {
                        return [2 /*return*/, { objects: [] }];
                    }
                    objects = tfliteResults.map(function (result) {
                        return {
                            boundingBox: result.boundingBox,
                            className: result.classes[0].className,
                            score: result.classes[0].probability,
                        };
                    });
                    finalResult = { objects: objects };
                    return [2 /*return*/, finalResult];
                });
            });
        };
        ObjectDetectorTFLite.prototype.cleanUp = function () {
            if (!this.tfliteObjectDetector) {
                throw new Error('source model is not loaded');
            }
            this.tfliteObjectDetector.cleanUp();
        };
        return ObjectDetectorTFLite;
    }(ObjectDetector));

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for cocossd TFLite model. */
    var CocoSsdTFLiteLoader = /** @class */ (function (_super) {
        __extends(CocoSsdTFLiteLoader, _super);
        function CocoSsdTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFLite COCO-SSD',
                description: 'Run COCO-SSD object detection model with TFLite',
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.OBJECT_DETECTION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        CocoSsdTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var url, tfliteObjectDetector;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://tfhub.dev/tensorflow/lite-model/' +
                                'ssd_mobilenet_v1/1/metadata/2?lite-format=tflite';
                            return [4 /*yield*/, sourceModelGlobal.ObjectDetector.create(url, loadingOptions)];
                        case 1:
                            tfliteObjectDetector = _a.sent();
                            return [2 /*return*/, new CocoSsdTFLite(tfliteObjectDetector)];
                    }
                });
            });
        };
        return CocoSsdTFLiteLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFLite coco-ssd object detection model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * const model = await tfTask.ObjectDetection.CocoSsd.TFLite.load();
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result.objects);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ObjectDetector` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'CocoSsdTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`',
     * symbol: 'CocoSsdTFLiteInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Object Detection', subheading: 'Models'}
     */
    var CocoSsdTFLite = /** @class */ (function (_super) {
        __extends(CocoSsdTFLite, _super);
        function CocoSsdTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return CocoSsdTFLite;
    }(ObjectDetectorTFLite));
    var cocoSsdTfliteLoader = new CocoSsdTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for custom object detection TFLite model. */
    var ObjectDetectionCustomModelTFLiteLoader = /** @class */ (function (_super) {
        __extends(ObjectDetectionCustomModelTFLiteLoader, _super);
        function ObjectDetectionCustomModelTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'Object detection with TFLite models',
                description: 'An object detector backed by the TFLite Task Library. ' +
                    'It can work with any models that meet the ' +
                    '<a href="https://www.tensorflow.org/lite/inference_with_metadata/' +
                    'task_library/object_detector#model_compatibility_requirements" ' +
                    'target="_blank">model requirements</a>. Try models from this ' +
                    '<a href="https://tfhub.dev/tensorflow/collections/lite/task-library/' +
                    'object-detector/1" target="_blank">collection</a>.',
                resourceUrls: {
                    'TFLite task library': 'https://www.tensorflow.org/lite/' +
                        'inference_with_metadata/task_library/overview',
                },
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.OBJECT_DETECTION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        ObjectDetectionCustomModelTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteObjectDetector;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.ObjectDetector.create(loadingOptions.model, loadingOptions)];
                        case 1:
                            tfliteObjectDetector = _a.sent();
                            return [2 /*return*/, new ODCustomModelTFLite(tfliteObjectDetector)];
                    }
                });
            });
        };
        return ObjectDetectionCustomModelTFLiteLoader;
    }(TaskModelLoader));
    /**
     * A custom TFLite object detection model loaded from a model url or an
     * `ArrayBuffer` in memory.
     *
     * The underlying object detector is built on top of the [TFLite Task
     * Library](https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview).
     * As a result, the custom model needs to meet the [metadata
     * requirements](https://www.tensorflow.org/lite/inference_with_metadata/task_library/object_detector#model_compatibility_requirements).
     *
     * Usage:
     *
     * ```js
     * // Load the model from a custom url with other options (optional).
     * const model = await tfTask.ObjectDetection.CustomModel.TFLite.load({
     *   model:
     * 'https://tfhub.dev/tensorflow/lite-model/ssd_mobilenet_v1/1/metadata/2?lite-format=tflite',
     * });
     *
     * // Run inference on an image.
     * const img = document.querySelector('img');
     * const result = await model.predict(img);
     * console.log(result.objects);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.ObjectDetector` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'ODCustomModelTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'ODCustomModelTFLiteInferenceOptions'}
     * ]
     *
     *
     * @doc {heading: 'Object Detection', subheading: 'Models'}
     */
    var ODCustomModelTFLite = /** @class */ (function (_super) {
        __extends(ODCustomModelTFLite, _super);
        function ODCustomModelTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ODCustomModelTFLite;
    }(ObjectDetectorTFLite));
    var objectDetectorCustomModelTfliteLoader = new ObjectDetectionCustomModelTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all Q&A task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'Question & Answer', subheading: 'Base model'}
     */
    var QuestionAnswerer = /** @class */ (function () {
        function QuestionAnswerer() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'Question & Answer', subheading: 'Base model'}
         */
        QuestionAnswerer.prototype.cleanUp = function () { };
        return QuestionAnswerer;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for Q&A TFJS model. */
    var BertQATFJSLoader = /** @class */ (function (_super) {
        __extends(BertQATFJSLoader, _super);
        function BertQATFJSLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFJS Bert Q&A model',
                description: 'Run Bert Q&A model with TFJS',
                resourceUrls: {
                    'github': 'https://github.com/tensorflow/tfjs-models/tree/master/qna',
                },
                runtime: Runtime.TFJS,
                version: '1.0.0',
                supportedTasks: [Task.QUESTION_AND_ANSWER],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow-models/qna@" + _this.metadata.version]];
            _this.sourceModelGlobalNamespace = 'qna';
            return _this;
        }
        BertQATFJSLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var modelConfig, bertQaModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            modelConfig = null;
                            if (loadingOptions && loadingOptions.modelUrl) {
                                modelConfig = { modelUrl: loadingOptions.modelUrl };
                            }
                            if (loadingOptions && loadingOptions.fromTFHub != null && modelConfig) {
                                modelConfig.fromTFHub = loadingOptions.fromTFHub;
                            }
                            return [4 /*yield*/, sourceModelGlobal.load(modelConfig)];
                        case 1:
                            bertQaModel = _a.sent();
                            return [2 /*return*/, new BertQATFJS(bertQaModel, loadingOptions)];
                    }
                });
            });
        };
        return BertQATFJSLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFJS Bert Q&A model.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * const model = await tfTask.QuestionAndAnswer.BertQA.TFJS.load();
     *
     * // Run inference with question and context.
     * const result = await model.predict(question, context);
     * console.log(result.answers);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.QuestionAnswerer` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol: 'BertQATFJSLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'BertQATFJSInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Question & Answer', subheading: 'Models'}
     */
    var BertQATFJS = /** @class */ (function (_super) {
        __extends(BertQATFJS, _super);
        function BertQATFJS(qnaModel, loadingOptions) {
            var _this = _super.call(this) || this;
            _this.qnaModel = qnaModel;
            _this.loadingOptions = loadingOptions;
            return _this;
        }
        BertQATFJS.prototype.predict = function (question, context, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var qnaResults;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.qnaModel) {
                                throw new Error('source model is not loaded');
                            }
                            return [4 /*yield*/, ensureTFJSBackend(this.loadingOptions)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.qnaModel.findAnswers(question, context)];
                        case 2:
                            qnaResults = _a.sent();
                            return [2 /*return*/, { answers: qnaResults }];
                    }
                });
            });
        };
        return BertQATFJS;
    }(QuestionAnswerer));
    var bertQaTfjsLoader = new BertQATFJSLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all Q&A TFLite models.
     *
     * @template T The type of inference options.
     */
    var QuestionAnswererTFLite = /** @class */ (function (_super) {
        __extends(QuestionAnswererTFLite, _super);
        function QuestionAnswererTFLite(tfliteQuestionAnswerer) {
            var _this = _super.call(this) || this;
            _this.tfliteQuestionAnswerer = tfliteQuestionAnswerer;
            return _this;
        }
        QuestionAnswererTFLite.prototype.predict = function (question, context, infereceOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, answers;
                return __generator(this, function (_a) {
                    if (!this.tfliteQuestionAnswerer) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteQuestionAnswerer.answer(context, question);
                    answers = tfliteResults.map(function (result) {
                        return {
                            text: result.text,
                            startIndex: result.pos.start,
                            endIndex: result.pos.end,
                            score: result.pos.logit,
                        };
                    });
                    return [2 /*return*/, { answers: answers }];
                });
            });
        };
        QuestionAnswererTFLite.prototype.cleanUp = function () {
            if (!this.tfliteQuestionAnswerer) {
                throw new Error('source model is not loaded');
            }
            this.tfliteQuestionAnswerer.cleanUp();
        };
        return QuestionAnswererTFLite;
    }(QuestionAnswerer));

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for Bert Q&A TFLite model. */
    var BertQATFLiteLoader = /** @class */ (function (_super) {
        __extends(BertQATFLiteLoader, _super);
        function BertQATFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFLite Bert Q&A model',
                description: 'Run Bert Q&A model with TFLite',
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.QUESTION_AND_ANSWER],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        BertQATFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var url, tfliteQa;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://tfhub.dev/tensorflow/lite-model/' +
                                'mobilebert/1/metadata/1?lite-format=tflite';
                            return [4 /*yield*/, sourceModelGlobal.BertQuestionAnswerer.create(url)];
                        case 1:
                            tfliteQa = _a.sent();
                            return [2 /*return*/, new BertQATFLite(tfliteQa)];
                    }
                });
            });
        };
        return BertQATFLiteLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFLite Bert Q&A model.
     *
     * Usage:
     *
     * ```js
     * // Load the model.
     * const model = await tfTask.QuestionAndAnswer.BertQA.TFLite.load();
     *
     * // Run inference on an image.
     * const result = await model.predict(question, context);
     * console.log(result);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.QuestionAnswerer` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'BertQATFLiteLoadingOptions'},
     *   {description: 'Options for `predict`',
     * symbol: 'BertQATFLiteInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Question & Answer', subheading: 'Models'}
     */
    var BertQATFLite = /** @class */ (function (_super) {
        __extends(BertQATFLite, _super);
        function BertQATFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return BertQATFLite;
    }(QuestionAnswererTFLite));
    var bertQaTfliteLoader = new BertQATFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for custom Q&A TFLite model. */
    var QuestionAnswerCustomModelTFLiteLoader = /** @class */ (function (_super) {
        __extends(QuestionAnswerCustomModelTFLiteLoader, _super);
        function QuestionAnswerCustomModelTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'Question&Answer with TFLite models',
                description: 'A QuestionAnswerer backed by the TFLite Task Library. ' +
                    'It can work with any models that meet the ' +
                    '<a href="https://www.tensorflow.org/lite/inference_with_metadata/' +
                    'task_library/bert_question_answerer#model_compatibility_requirements" ' +
                    'target="_blank">model requirements</a>. Try models from this ' +
                    '<a href="https://tfhub.dev/tensorflow/collections/lite/task-library/' +
                    'bert-question-answerer/1" target="_blank">collection</a>.',
                resourceUrls: {
                    'TFLite task library': 'https://www.tensorflow.org/lite/' +
                        'inference_with_metadata/task_library/overview',
                },
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.QUESTION_AND_ANSWER],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        QuestionAnswerCustomModelTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteQa;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.BertQuestionAnswerer.create(loadingOptions.model)];
                        case 1:
                            tfliteQa = _a.sent();
                            return [2 /*return*/, new QACustomModelTFLite(tfliteQa)];
                    }
                });
            });
        };
        return QuestionAnswerCustomModelTFLiteLoader;
    }(TaskModelLoader));
    /**
     * A custom TFLite Q&A model loaded from a model url or an `ArrayBuffer` in
     * memory.
     *
     * The underlying question answerer is built on top of the [TFLite Task
     * Library](https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview).
     * As a result, the custom model needs to meet the [metadata
     * requirements](https://www.tensorflow.org/lite/inference_with_metadata/task_library/bert_question_answerer#model_compatibility_requirements).
     *
     * Usage:
     *
     * ```js
     * // Load the model from a custom url.
     * const model = await tfTask.QuestionAndAnswer.CustomModel.TFLite.load({
     *   model:
     * 'https://tfhub.dev/tensorflow/lite-model/mobilebert/1/metadata/1?lite-format=tflite',
     * });
     *
     * // Run inference with question and context.
     * const result = await model.predict(question, context);
     * console.log(result.answers);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * Refer to `tfTask.QuestionAnswerer` for the `predict` and `cleanUp` method.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'QACustomModelTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'QACustomModelTFLiteInferenceOptions'}
     * ]
     *
     *
     * @doc {heading: 'Question & Answer', subheading: 'Models'}
     */
    var QACustomModelTFLite = /** @class */ (function (_super) {
        __extends(QACustomModelTFLite, _super);
        function QACustomModelTFLite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return QACustomModelTFLite;
    }(QuestionAnswererTFLite));
    var qaCustomModelTfliteLoader = new QuestionAnswerCustomModelTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /**
     * The base class for all SentimentDetection task models.
     *
     * @template IO The type of options used during the inference process. Different
     *     models have different inference options. See individual model for more
     *     details.
     *
     * @doc {heading: 'Sentiment Detection', subheading: 'Base model'}
     */
    var SentimentDetector = /** @class */ (function () {
        function SentimentDetector() {
        }
        /**
         * Cleans up resources if needed.
         *
         * @doc {heading: 'Sentiment Detection', subheading: 'Base model'}
         */
        SentimentDetector.prototype.cleanUp = function () { };
        return SentimentDetector;
    }());

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    var DEFAULT_THRESHOLD = 0.5;
    /** Loader for cocossd TFLite model. */
    var MovieReviewTFLiteLoader = /** @class */ (function (_super) {
        __extends(MovieReviewTFLiteLoader, _super);
        function MovieReviewTFLiteLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFLite movie review model',
                description: 'Run a movie review model with TFLite and output ' +
                    'the probabilities of whether the review is positive or negetive.',
                runtime: Runtime.TFLITE,
                version: '0.0.1-alpha.3',
                supportedTasks: [Task.SENTIMENT_DETECTION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@" + _this.metadata.version + "/dist/tf-tflite.min.js"]];
            _this.sourceModelGlobalNamespace = 'tflite';
            return _this;
        }
        MovieReviewTFLiteLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var url, tfliteNLClassifier, threshold;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            url = 'https://storage.googleapis.com/tfweb/models/' +
                                'movie_review_sentiment_classification.tflite';
                            return [4 /*yield*/, sourceModelGlobal.NLClassifier.create(url, getNLClassifierOptions())];
                        case 1:
                            tfliteNLClassifier = _a.sent();
                            threshold = loadingOptions && loadingOptions.threshold != null ?
                                loadingOptions.threshold :
                                DEFAULT_THRESHOLD;
                            return [2 /*return*/, new MovieReviewTFLite(tfliteNLClassifier, threshold)];
                    }
                });
            });
        };
        return MovieReviewTFLiteLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFLite movie review sentiment detection model.
     *
     * It detects whether the review text is positive or negetive.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional).
     * const model = await tfTask.SentimentDetection.MovieReview.TFLite.load();
     *
     * // Run inference on a review text.
     * const result = await model.predict('This is a great movie!');
     * console.log(result.sentimentLabels);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * The model returns the prediction results of the following sentiment labels:
     *
     * - positive
     * - negative
     *
     * Refer to `tfTask.SentimentDetector` for the `predict` and `cleanUp` method,
     * and more details about the result interface.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol:
     * 'MovieReviewTFLiteLoadingOptions'},
     *   {description: 'Options for `predict`',
     * symbol: 'MovieReviewTFLiteInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Sentiment Detection', subheading: 'Models'}
     */
    var MovieReviewTFLite = /** @class */ (function (_super) {
        __extends(MovieReviewTFLite, _super);
        function MovieReviewTFLite(tfliteNLClassifier, threshold) {
            var _this = _super.call(this) || this;
            _this.tfliteNLClassifier = tfliteNLClassifier;
            _this.threshold = threshold;
            return _this;
        }
        MovieReviewTFLite.prototype.predict = function (text, options) {
            return __awaiter(this, void 0, void 0, function () {
                var tfliteResults, negativeProbability, positiveProbability, positiveResult, negativeResult;
                return __generator(this, function (_a) {
                    if (!this.tfliteNLClassifier) {
                        throw new Error('source model is not loaded');
                    }
                    tfliteResults = this.tfliteNLClassifier.classify(text);
                    if (!tfliteResults) {
                        return [2 /*return*/, { sentimentLabels: {} }];
                    }
                    negativeProbability = tfliteResults[0].probability;
                    positiveProbability = tfliteResults[1].probability;
                    positiveResult = null;
                    negativeResult = null;
                    if (Math.max(negativeProbability, positiveProbability) > this.threshold) {
                        positiveResult = positiveProbability > negativeProbability;
                        negativeResult = positiveProbability < negativeProbability;
                    }
                    return [2 /*return*/, {
                            sentimentLabels: {
                                'positive': {
                                    result: positiveResult,
                                    probabilities: [negativeProbability, positiveProbability],
                                },
                                'negative': {
                                    result: negativeResult,
                                    probabilities: [positiveProbability, negativeProbability],
                                }
                            }
                        }];
                });
            });
        };
        return MovieReviewTFLite;
    }(SentimentDetector));
    var movieReviewTfliteLoader = new MovieReviewTFLiteLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    /** Loader for toxicity TFJS model. */
    var ToxicityTFJSLoader = /** @class */ (function (_super) {
        __extends(ToxicityTFJSLoader, _super);
        function ToxicityTFJSLoader() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.metadata = {
                name: 'TFJS Toxicity model',
                description: 'Detect whether text contains toxic content such as ' +
                    'threatening language, insults, obscenities, identity-based hate, ' +
                    'or sexually explicit language.',
                resourceUrls: {
                    'github': 'https://github.com/tensorflow/tfjs-models/tree/master/toxicity',
                },
                runtime: Runtime.TFJS,
                version: '1.2.2',
                supportedTasks: [Task.SENTIMENT_DETECTION],
            };
            _this.packageUrls = [["https://cdn.jsdelivr.net/npm/@tensorflow-models/toxicity@" + _this.metadata.version]];
            _this.sourceModelGlobalNamespace = 'toxicity';
            return _this;
        }
        ToxicityTFJSLoader.prototype.transformSourceModel = function (sourceModelGlobal, loadingOptions) {
            return __awaiter(this, void 0, void 0, function () {
                var toxicityModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, sourceModelGlobal.load(loadingOptions && loadingOptions.threshold ? loadingOptions.threshold :
                                0.85, loadingOptions && loadingOptions.toxicityLabels ?
                                loadingOptions.toxicityLabels :
                                [])];
                        case 1:
                            toxicityModel = _a.sent();
                            return [2 /*return*/, new ToxicityTFJS(toxicityModel, loadingOptions)];
                    }
                });
            });
        };
        return ToxicityTFJSLoader;
    }(TaskModelLoader));
    /**
     * Pre-trained TFJS toxicity model.
     *
     * It detects whether text contains toxic content such as threatening language,
     * insults, obscenities, identity-based hate, or sexually explicit language.
     *
     * Usage:
     *
     * ```js
     * // Load the model with options (optional. See below for docs).
     * const model = await tfTask.SentimentDetection.Toxicity.TFJS.load();
     *
     * // Run detection on text.
     * const result = await model.predict('You are stupid');
     * console.log(result.sentimentLabels);
     *
     * // Clean up.
     * model.cleanUp();
     * ```
     *
     * By default, the model returns the prediction results of the following
     * sentiment labels:
     *
     * - toxicity
     * - severe_toxicity
     * - identity_attack
     * - insult
     * - threat
     * - sexual_explicit
     * - obscene
     *
     * Refer to `tfTask.SentimentDetection` for the `predict` and `cleanUp` method,
     * and more details about the result interface.
     *
     * @docextratypes [
     *   {description: 'Options for `load`', symbol: 'ToxicityTFJSLoadingOptions'},
     *   {description: 'Options for `predict`', symbol:
     * 'ToxicityTFJSInferenceOptions'}
     * ]
     *
     * @doc {heading: 'Sentiment Detection', subheading: 'Models'}
     */
    var ToxicityTFJS = /** @class */ (function (_super) {
        __extends(ToxicityTFJS, _super);
        function ToxicityTFJS(toxicityModel, loadingOptions) {
            var _this = _super.call(this) || this;
            _this.toxicityModel = toxicityModel;
            _this.loadingOptions = loadingOptions;
            return _this;
        }
        ToxicityTFJS.prototype.predict = function (text, options) {
            return __awaiter(this, void 0, void 0, function () {
                var toxicityResults, sentimentLabels, _i, toxicityResults_1, labelResult;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.toxicityModel) {
                                throw new Error('source model is not loaded');
                            }
                            return [4 /*yield*/, ensureTFJSBackend(this.loadingOptions)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.toxicityModel.classify(text)];
                        case 2:
                            toxicityResults = _a.sent();
                            sentimentLabels = {};
                            for (_i = 0, toxicityResults_1 = toxicityResults; _i < toxicityResults_1.length; _i++) {
                                labelResult = toxicityResults_1[_i];
                                sentimentLabels[labelResult.label] = {
                                    result: labelResult.results[0].match,
                                    probabilities: Array.from(labelResult.results[0].probabilities),
                                };
                            }
                            return [2 /*return*/, { sentimentLabels: sentimentLabels }];
                    }
                });
            });
        };
        return ToxicityTFJS;
    }(SentimentDetector));
    var toxicityTfjsLoader = new ToxicityTFJSLoader();

    /**
     * @license
     * Copyright 2021 Google LLC. All Rights Reserved.
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     * =============================================================================
     */
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    /**
     * The main model index.
     *
     * The index structure is: {task_name}.{model_name}.{runtime}
     *
     * Note that it is possible to programmatically generate the index from a list
     * of loaders, but it would mean that we need to define a generic type for
     * each level of the index structure (e.g. {[taskName: string]: TaskModels}).
     * This will not work well for the auto-complete system in IDEs because
     * typescript doesn't know the candidates to show from the generic types.
     *
     * For this reason, we chose to create the index manually like below. In this
     * way, typescript will infer the types based on the content statically, and
     * correctly show the candidates when doing auto-complete.
     *
     * TODO: add test to make sure loaders are located in the correct index entries.
     */
    var modelIndex = (_a = {},
        _a[Task.IMAGE_CLASSIFICATION] = {
            MobileNet: (_b = {},
                _b[Runtime.TFJS] = mobilenetTfjsLoader,
                _b[Runtime.TFLITE] = mobilenetTfliteLoader,
                _b),
            CustomModel: (_c = {},
                _c[Runtime.TFLITE] = imageClassificationCustomModelTfliteLoader,
                _c),
        },
        _a[Task.OBJECT_DETECTION] = {
            CocoSsd: (_d = {},
                _d[Runtime.TFJS] = cocoSsdTfjsLoader,
                _d[Runtime.TFLITE] = cocoSsdTfliteLoader,
                _d),
            CustomModel: (_e = {},
                _e[Runtime.TFLITE] = objectDetectorCustomModelTfliteLoader,
                _e),
        },
        _a[Task.IMAGE_SEGMENTATION] = {
            Deeplab: (_f = {},
                _f[Runtime.TFJS] = deeplabTfjsLoader,
                _f[Runtime.TFLITE] = deeplabTfliteLoader,
                _f),
            CustomModel: (_g = {},
                _g[Runtime.TFLITE] = imageSegmenterCustomModelTfliteLoader,
                _g),
        },
        _a[Task.SENTIMENT_DETECTION] = {
            MovieReview: (_h = {},
                _h[Runtime.TFLITE] = movieReviewTfliteLoader,
                _h),
            Toxicity: (_j = {},
                _j[Runtime.TFJS] = toxicityTfjsLoader,
                _j)
        },
        _a[Task.NL_CLASSIFICATION] = {
            CustomModel: (_k = {},
                _k[Runtime.TFLITE] = nlClassifierCustomModelTfliteLoader,
                _k),
        },
        _a[Task.QUESTION_AND_ANSWER] = {
            BertQA: (_l = {},
                _l[Runtime.TFJS] = bertQaTfjsLoader,
                _l[Runtime.TFLITE] = bertQaTfliteLoader,
                _l),
            CustomModel: (_m = {},
                _m[Runtime.TFLITE] = qaCustomModelTfliteLoader,
                _m)
        },
        _a);
    // Export each task individually.
    var ImageClassification = modelIndex[Task.IMAGE_CLASSIFICATION];
    var ObjectDetection = modelIndex[Task.OBJECT_DETECTION];
    var ImageSegmentation = modelIndex[Task.IMAGE_SEGMENTATION];
    var SentimentDetection = modelIndex[Task.SENTIMENT_DETECTION];
    var NLClassification = modelIndex[Task.NL_CLASSIFICATION];
    var QuestionAndAnswer = modelIndex[Task.QUESTION_AND_ANSWER];
    /**
     * Filter model loaders by runtimes.
     *
     * A model loader will be returned if its runtime matches any runtime in the
     * given array.
     */
    function getModelLoadersByRuntime(runtimes) {
        return filterModelLoaders(function (loader) { return runtimes.includes(loader.metadata.runtime); });
    }
    /** Gets all model loaders from the index. */
    function getAllModelLoaders() {
        var modelLoaders = [];
        for (var _i = 0, _a = Object.keys(modelIndex); _i < _a.length; _i++) {
            var task = _a[_i];
            // tslint:disable-next-line:no-any
            var models = modelIndex[task];
            for (var _b = 0, _c = Object.keys(models); _b < _c.length; _b++) {
                var modelName = _c[_b];
                var runtimes = models[modelName];
                for (var _d = 0, _e = Object.keys(runtimes); _d < _e.length; _d++) {
                    var runtime = _e[_d];
                    var taskModel = runtimes[runtime];
                    modelLoaders.push(taskModel);
                }
            }
        }
        return modelLoaders;
    }
    function filterModelLoaders(filterFn) {
        var filteredModelLoaders = [];
        for (var _i = 0, _a = getAllModelLoaders(); _i < _a.length; _i++) {
            var modelLoader = _a[_i];
            if (filterFn(modelLoader)) {
                filteredModelLoaders.push(modelLoader);
            }
        }
        return filteredModelLoaders;
    }
    // TODO: add more util functions as needed.

    /** @license See the LICENSE file. */
    // This code is auto-generated, do not modify this file!
    var version = '0.0.1-alpha.8';

    exports.ICCustomModelTFLite = ICCustomModelTFLite;
    exports.ImageClassification = ImageClassification;
    exports.ImageClassificationCustomModelTFLiteLoader = ImageClassificationCustomModelTFLiteLoader;
    exports.ImageSegmentation = ImageSegmentation;
    exports.MobilenetTFJS = MobilenetTFJS;
    exports.MobilenetTFJSLoader = MobilenetTFJSLoader;
    exports.MobilenetTFLite = MobilenetTFLite;
    exports.MobilenetTFLiteLoader = MobilenetTFLiteLoader;
    exports.NLClassification = NLClassification;
    exports.ObjectDetection = ObjectDetection;
    exports.QuestionAndAnswer = QuestionAndAnswer;
    exports.SentimentDetection = SentimentDetection;
    exports.TaskModelLoader = TaskModelLoader;
    exports.getAllModelLoaders = getAllModelLoaders;
    exports.getModelLoadersByRuntime = getModelLoadersByRuntime;
    exports.imageClassificationCustomModelTfliteLoader = imageClassificationCustomModelTfliteLoader;
    exports.mobilenetTfjsLoader = mobilenetTfjsLoader;
    exports.mobilenetTfliteLoader = mobilenetTfliteLoader;
    exports.version = version;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=tfjs-tasks.js.map
