/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tfTask={})}(this,function(e){"use strict";function o(){return"undefined"==typeof window}class a{async loadPackagesAndGetGlobalNamespace(e,t,s=0){if(s>=t.length){var a=(o()?self:window)[e];if(!a)throw new Error(`Global namespace '${e}' not set after loading packages ${t}`);return a}return await Promise.all(t[s].map(e=>this.loadPackage(e))),await this.loadPackagesAndGetGlobalNamespace(e,t,s+1)}async loadPackage(e){if(a.promises[e])return a.promises[e];if(o())importScripts(e),a.promises[e]=Promise.resolve();else{const s=document.createElement("script");s.crossOrigin="anonymous";var t=new Promise((e,t)=>{s.onerror=()=>{t(),document.head.removeChild(s)},s.onload=()=>{e()}});document.head.appendChild(s),s.setAttribute("src",e),a.promises[e]=t}return a.promises[e]}}a.promises={};const r="webgl";var t,s;(z=t=t||{}).IMAGE_CLASSIFICATION="IMAGE_CLASSIFICATION",z.OBJECT_DETECTION="OBJECT_DETECTION",z.IMAGE_SEGMENTATION="IMAGE_SEGMENTATION",z.SENTIMENT_DETECTION="SENTIMENT_DETECTION",z.NL_CLASSIFICATION="NL_CLASSIFICATION",z.QUESTION_AND_ANSWER="QUESTION_AND_ANSWER",(X=s=s||{}).TFJS="TFJS",X.TFLITE="TFLite",X.MEDIA_PIPE="MediaPipe";async function i(e){e=e?e.backend:r;const t=(o()?self:window).tf;if(!t)throw new Error("tfjs not loaded");t.getBackend()!==e&&await t.setBackend(e)}class n{constructor(){this.postPackageLoadingCallback=void 0,this.packageLoader=new a}async load(e){var t=await this.loadSourceModelGlobalNamespace(e);return this.postPackageLoadingCallback&&await this.postPackageLoadingCallback(),this.metadata.runtime===s.TFJS&&await i(e),this.transformSourceModel(t,e)}async loadSourceModelGlobalNamespace(e){const t=[];return this.metadata.runtime===s.TFJS&&t.push(...function(e=r,t="3.6.0"){const s=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-core@${t}`],[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-converter@${t}`]];switch(e){case"cpu":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@${t}`);break;case"webgl":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@${t}`),s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-webgl@${t}`);break;case"wasm":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-wasm@${t}/dist/tf-backend-wasm.min.js`)}return s}(e?e.backend:void 0)),t.push(...this.packageUrls),await this.packageLoader.loadPackagesAndGetGlobalNamespace(this.sourceModelGlobalNamespace,t)}async transformSourceModel(e,t){throw new Error("not implemented")}}class l{cleanUp(){}}class c extends l{constructor(e){super(),this.tfliteImageClassifier=e}async predict(e,t){if(!this.tfliteImageClassifier)throw new Error("source model is not loaded");const s=this.tfliteImageClassifier.classify(e);return s?{classes:s.map(e=>({className:e.className,score:e.probability}))}:{classes:[]}}cleanUp(){if(!this.tfliteImageClassifier)throw new Error("source model is not loaded");this.tfliteImageClassifier.cleanUp()}}class d extends n{constructor(){super(...arguments),this.metadata={name:"Image classification with TFLite models",description:'An image classfier backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_classifier#model_compatibility_requirements" target:"_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/image-classifier/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageClassifier.create(t.model,t);return new m(t)}}class m extends c{}var u=new d;class h extends n{constructor(){super(...arguments),this.metadata={name:"TFJS Mobilenet",description:"Run mobilenet image classification model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/mobilenet"},runtime:s.TFJS,version:"2.1.0",supportedTasks:[t.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/mobilenet@${this.metadata.version}`]],this.sourceModelGlobalNamespace="mobilenet"}async transformSourceModel(e,t){e=await e.load(t);return new p(e,t)}}class p extends l{constructor(e,t){super(),this.mobilenetModel=e,this.loadingOptions=t}async predict(e,t){if(!this.mobilenetModel)throw new Error("source model is not loaded");await i(this.loadingOptions);const s=await this.mobilenetModel.classify(e,t?t.topK:void 0);return{classes:s.map(e=>({className:e.className,score:e.probability}))}}}var f=new h;class w extends n{constructor(){super(...arguments),this.metadata={name:"TFLite Mobilenet",description:"Run mobilenet image classification model with TFLite",runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){let s="1",a="1.0";t&&(void 0!==t.version&&(s=String(t.version)),void 0!==t.alpha&&(a=String(t.alpha))),"2"===s&&"1.0"!==a&&(a="1.0",console.warn(`No mobilenet TFLite model available for ${s}_${a}. Using 2_1.0 instead.`));var o=`https://storage.googleapis.com/tfweb/models/mobilenet_v${s}_${a}_224_1_metadata_1.tflite`,t=await e.ImageClassifier.create(o,t);return new T(t)}}class T extends c{}var b=new w;class g{cleanUp(){}}class I extends g{constructor(e){super(),this.tfliteImageSegmenter=e}async predict(e,t){if(!this.tfliteImageSegmenter)throw new Error("source model is not loaded");e=this.tfliteImageSegmenter.segment(e);if(!e)return{legend:{},width:-1,height:-1,segmentationMap:void 0};var s=e[0];const a={},o=[];for(const n of s.coloredLabels)a[n.className||n.displayName]=n,o.push(n);const r=new Uint8ClampedArray(s.width*s.height*4);for(let e=0;e<s.categoryMask.length;e++){var i=s.categoryMask[e],i=o[i];r[4*e]=i.r,r[4*e+1]=i.g,r[4*e+2]=i.b,r[4*e+3]=255}return{legend:a,width:s.width,height:s.height,segmentationMap:r}}cleanUp(){if(!this.tfliteImageSegmenter)throw new Error("source model is not loaded");this.tfliteImageSegmenter.cleanUp()}}class N extends I{}var E=new class extends n{constructor(){super(...arguments),this.metadata={name:"Image segmentation with TFLite models",description:'An image segmentation backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_segmenter#model_compatibility_requirements" target="_blank">model requirements</a>.Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/image-segmenter/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageSegmenter.create(t.model,t);return new N(t)}};class S extends g{constructor(e,t){super(),this.deeplabModel=e,this.loadingOptions=t}async predict(e,t){if(!this.deeplabModel)throw new Error("source model is not loaded");await i(this.loadingOptions);var s=await this.deeplabModel.segment(e,t);const a={};for(const r of Object.keys(s.legend)){var o=s.legend[r];a[r]={r:o[0],g:o[1],b:o[2]}}return{legend:a,width:s.width,height:s.height,segmentationMap:s.segmentationMap}}cleanUp(){if(!this.deeplabModel)throw new Error("source model is not loaded");this.deeplabModel.dispose()}}var v=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFJS Deeplab",description:"Run deeplab image segmentation model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/deeplab"},runtime:s.TFJS,version:"0.2.1",supportedTasks:[t.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/deeplab@${this.metadata.version}`]],this.sourceModelGlobalNamespace="deeplab"}async transformSourceModel(e,t){const s=Object.assign({},t)||{backend:"webgl"};null==s.base&&(s.base="pascal"),null==s.quantizationBytes&&(s.quantizationBytes=2);e=await e.load(s);return new S(e,s)}};class _ extends I{}var y=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFLite Deeplab",description:"Run Deeplab image segmentation model with TFLite",runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageSegmenter.create("https://tfhub.dev/tensorflow/lite-model/deeplabv3/1/metadata/2?lite-format=tflite",t);return new _(t)}};function L(e){const t={inputTensorIndex:0,outputScoreTensorIndex:0,outputLabelTensorIndex:-1,inputTensorName:"INPUT",outputScoreTensorName:"OUTPUT_SCORE",outputLabelTensorName:"OUTPUT_LABEL"};return e&&(null!=e.inputTensorIndex&&(t.inputTensorIndex=e.inputTensorIndex),null!=e.outputScoreTensorIndex&&(t.outputScoreTensorIndex=e.outputScoreTensorIndex),null!=e.outputLabelTensorIndex&&(t.outputLabelTensorIndex=e.outputLabelTensorIndex),null!=e.inputTensorName&&(t.inputTensorName=e.inputTensorName),null!=e.outputScoreTensorName&&(t.outputScoreTensorName=e.outputScoreTensorName),null!=e.outputLabelTensorName&&(t.outputLabelTensorName=e.outputLabelTensorName)),t}class M extends class extends class{cleanUp(){}}{constructor(e){super(),this.tfliteNLClassifier=e}async predict(e,t){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");const s=this.tfliteNLClassifier.classify(e);return s?{classes:s.map(e=>({className:e.className,score:e.probability}))}:{classes:[]}}cleanUp(){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");this.tfliteNLClassifier.cleanUp()}}{}var k=new class extends n{constructor(){super(...arguments),this.metadata={name:"Natural language classification with TFLite models",description:'A natural language detector backed by the NLClassifier in TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/nl_classifier#model_compatibility_requirements" target="_blank">model requirements</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.NL_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.NLClassifier.create(t.model,L(t));return new M(t)}};class F{cleanUp(){}}class C extends F{constructor(e,t){super(),this.cocoSsdModel=e,this.loadingOptions=t}async predict(e,t){if(!this.cocoSsdModel)throw new Error("source model is not loaded");await i(this.loadingOptions);const s=await this.cocoSsdModel.detect(e,t?t.maxNumBoxes:void 0,t?t.minScore:void 0);return{objects:s.map(e=>({boundingBox:{originX:e.bbox[0],originY:e.bbox[1],width:e.bbox[2],height:e.bbox[3]},className:e.class,score:e.score}))}}cleanUp(){if(!this.cocoSsdModel)throw new Error("source model is not loaded");return this.cocoSsdModel.dispose()}}var A=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFJS COCO-SSD",description:"Run COCO-SSD object detection model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/coco-ssd"},runtime:s.TFJS,version:"2.2.2",supportedTasks:[t.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/coco-ssd@${this.metadata.version}`]],this.sourceModelGlobalNamespace="cocoSsd"}async transformSourceModel(e,t){e=await e.load(t);return new C(e,t)}};class O extends F{constructor(e){super(),this.tfliteObjectDetector=e}async predict(e,t){if(!this.tfliteObjectDetector)throw new Error("source model is not loaded");const s=this.tfliteObjectDetector.detect(e);return s?{objects:s.map(e=>({boundingBox:e.boundingBox,className:e.classes[0].className,score:e.classes[0].probability}))}:{objects:[]}}cleanUp(){if(!this.tfliteObjectDetector)throw new Error("source model is not loaded");this.tfliteObjectDetector.cleanUp()}}class j extends O{}var x=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFLite COCO-SSD",description:"Run COCO-SSD object detection model with TFLite",runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ObjectDetector.create("https://tfhub.dev/tensorflow/lite-model/ssd_mobilenet_v1/1/metadata/2?lite-format=tflite",t);return new j(t)}};class U extends O{}var G=new class extends n{constructor(){super(...arguments),this.metadata={name:"Object detection with TFLite models",description:'An object detector backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/object_detector#model_compatibility_requirements" target="_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/object-detector/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ObjectDetector.create(t.model,t);return new U(t)}};class D{cleanUp(){}}class J extends D{constructor(e,t){super(),this.qnaModel=e,this.loadingOptions=t}async predict(e,t,s){if(!this.qnaModel)throw new Error("source model is not loaded");return await i(this.loadingOptions),{answers:await this.qnaModel.findAnswers(e,t)}}}var $=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFJS Bert Q&A model",description:"Run Bert Q&A model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/qna"},runtime:s.TFJS,version:"1.0.0",supportedTasks:[t.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/qna@${this.metadata.version}`]],this.sourceModelGlobalNamespace="qna"}async transformSourceModel(e,t){let s=null;t&&t.modelUrl&&(s={modelUrl:t.modelUrl}),t&&null!=t.fromTFHub&&s&&(s.fromTFHub=t.fromTFHub);e=await e.load(s);return new J(e,t)}};class B extends D{constructor(e){super(),this.tfliteQuestionAnswerer=e}async predict(e,t,s){if(!this.tfliteQuestionAnswerer)throw new Error("source model is not loaded");const a=this.tfliteQuestionAnswerer.answer(t,e);return{answers:a.map(e=>({text:e.text,startIndex:e.pos.start,endIndex:e.pos.end,score:e.pos.logit}))}}cleanUp(){if(!this.tfliteQuestionAnswerer)throw new Error("source model is not loaded");this.tfliteQuestionAnswerer.cleanUp()}}class Q extends B{}var q=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFLite Bert Q&A model",description:"Run Bert Q&A model with TFLite",runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){e=await e.BertQuestionAnswerer.create("https://tfhub.dev/tensorflow/lite-model/mobilebert/1/metadata/1?lite-format=tflite");return new Q(e)}};class R extends B{}var P=new class extends n{constructor(){super(...arguments),this.metadata={name:"Question&Answer with TFLite models",description:'A QuestionAnswerer backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/bert_question_answerer#model_compatibility_requirements" target="_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/bert-question-answerer/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.BertQuestionAnswerer.create(t.model);return new R(t)}};class W{cleanUp(){}}class H extends W{constructor(e,t){super(),this.tfliteNLClassifier=e,this.threshold=t}async predict(e,t){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");var s=this.tfliteNLClassifier.classify(e);if(!s)return{sentimentLabels:{}};e=s[0].probability,s=s[1].probability;let a=null,o=null;return Math.max(e,s)>this.threshold&&(a=e<s,o=s<e),{sentimentLabels:{positive:{result:a,probabilities:[e,s]},negative:{result:o,probabilities:[s,e]}}}}}var z=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFLite movie review model",description:"Run a movie review model with TFLite and output the probabilities of whether the review is positive or negetive.",runtime:s.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[t.SENTIMENT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){e=await e.NLClassifier.create("https://storage.googleapis.com/tfweb/models/movie_review_sentiment_classification.tflite",L()),t=t&&null!=t.threshold?t.threshold:.5;return new H(e,t)}};class K extends W{constructor(e,t){super(),this.toxicityModel=e,this.loadingOptions=t}async predict(e,t){if(!this.toxicityModel)throw new Error("source model is not loaded");await i(this.loadingOptions);const s={};for(const a of await this.toxicityModel.classify(e))s[a.label]={result:a.results[0].match,probabilities:Array.from(a.results[0].probabilities)};return{sentimentLabels:s}}}var X=new class extends n{constructor(){super(...arguments),this.metadata={name:"TFJS Toxicity model",description:"Detect whether text contains toxic content such as threatening language, insults, obscenities, identity-based hate, or sexually explicit language.",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/toxicity"},runtime:s.TFJS,version:"1.2.2",supportedTasks:[t.SENTIMENT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/toxicity@${this.metadata.version}`]],this.sourceModelGlobalNamespace="toxicity"}async transformSourceModel(e,t){e=await e.load(t&&t.threshold?t.threshold:.85,t&&t.toxicityLabels?t.toxicityLabels:[]);return new K(e,t)}};const Y={[t.IMAGE_CLASSIFICATION]:{MobileNet:{[s.TFJS]:f,[s.TFLITE]:b},CustomModel:{[s.TFLITE]:u}},[t.OBJECT_DETECTION]:{CocoSsd:{[s.TFJS]:A,[s.TFLITE]:x},CustomModel:{[s.TFLITE]:G}},[t.IMAGE_SEGMENTATION]:{Deeplab:{[s.TFJS]:v,[s.TFLITE]:y},CustomModel:{[s.TFLITE]:E}},[t.SENTIMENT_DETECTION]:{MovieReview:{[s.TFLITE]:z},Toxicity:{[s.TFJS]:X}},[t.NL_CLASSIFICATION]:{CustomModel:{[s.TFLITE]:k}},[t.QUESTION_AND_ANSWER]:{BertQA:{[s.TFJS]:$,[s.TFLITE]:q},CustomModel:{[s.TFLITE]:P}}};z=Y[t.IMAGE_CLASSIFICATION],X=Y[t.OBJECT_DETECTION],k=Y[t.IMAGE_SEGMENTATION],$=Y[t.SENTIMENT_DETECTION],q=Y[t.NL_CLASSIFICATION],P=Y[t.QUESTION_AND_ANSWER];function V(){const e=[];for(const o of Object.keys(Y)){var t=Y[o];for(const r of Object.keys(t)){var s=t[r];for(const i of Object.keys(s)){var a=s[i];e.push(a)}}}return e}e.ICCustomModelTFLite=m,e.ImageClassification=z,e.ImageClassificationCustomModelTFLiteLoader=d,e.ImageSegmentation=k,e.MobilenetTFJS=p,e.MobilenetTFJSLoader=h,e.MobilenetTFLite=T,e.MobilenetTFLiteLoader=w,e.NLClassification=q,e.ObjectDetection=X,e.QuestionAndAnswer=P,e.SentimentDetection=$,e.TaskModelLoader=n,e.getAllModelLoaders=V,e.getModelLoadersByRuntime=function(t){return function(e){const t=[];for(const s of V())e(s)&&t.push(s);return t}(e=>t.includes(e.metadata.runtime))},e.imageClassificationCustomModelTfliteLoader=u,e.mobilenetTfjsLoader=f,e.mobilenetTfliteLoader=b,e.version="0.0.1-alpha.8",Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=tfjs-tasks.es2017.min.js.map
