/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
function isWebWorker(){return"undefined"==typeof window}class PackageLoader{async loadPackagesAndGetGlobalNamespace(e,t,s=0){if(s>=t.length){var o=(isWebWorker()?self:window)[e];if(!o)throw new Error(`Global namespace '${e}' not set after loading packages ${t}`);return o}return await Promise.all(t[s].map(e=>this.loadPackage(e))),await this.loadPackagesAndGetGlobalNamespace(e,t,s+1)}async loadPackage(e){if(PackageLoader.promises[e])return PackageLoader.promises[e];if(isWebWorker())importScripts(e),PackageLoader.promises[e]=Promise.resolve();else{const s=document.createElement("script");s.crossOrigin="anonymous";var t=new Promise((e,t)=>{s.onerror=()=>{t(),document.head.removeChild(s)},s.onload=()=>{e()}});document.head.appendChild(s),s.setAttribute("src",e),PackageLoader.promises[e]=t}return PackageLoader.promises[e]}}PackageLoader.promises={};const DEFAULT_TFJS_BACKEND="webgl",DEFAULT_TFJS_VERSION="3.6.0";var Task,Runtime;function getTFJSModelDependencyPackages(e=DEFAULT_TFJS_BACKEND,t=DEFAULT_TFJS_VERSION){const s=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-core@${t}`],[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-converter@${t}`]];switch(e){case"cpu":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@${t}`);break;case"webgl":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-cpu@${t}`),s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-webgl@${t}`);break;case"wasm":s[1].push(`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-backend-wasm@${t}/dist/tf-backend-wasm.min.js`)}return s}!function(e){e.IMAGE_CLASSIFICATION="IMAGE_CLASSIFICATION",e.OBJECT_DETECTION="OBJECT_DETECTION",e.IMAGE_SEGMENTATION="IMAGE_SEGMENTATION",e.SENTIMENT_DETECTION="SENTIMENT_DETECTION",e.NL_CLASSIFICATION="NL_CLASSIFICATION",e.QUESTION_AND_ANSWER="QUESTION_AND_ANSWER"}(Task=Task||{}),function(e){e.TFJS="TFJS",e.TFLITE="TFLite",e.MEDIA_PIPE="MediaPipe"}(Runtime=Runtime||{});async function ensureTFJSBackend(e){e=e?e.backend:DEFAULT_TFJS_BACKEND;const t=(isWebWorker()?self:window).tf;if(!t)throw new Error("tfjs not loaded");t.getBackend()!==e&&await t.setBackend(e)}class TaskModelLoader{constructor(){this.postPackageLoadingCallback=void 0,this.packageLoader=new PackageLoader}async load(e){var t=await this.loadSourceModelGlobalNamespace(e);return this.postPackageLoadingCallback&&await this.postPackageLoadingCallback(),this.metadata.runtime===Runtime.TFJS&&await ensureTFJSBackend(e),this.transformSourceModel(t,e)}async loadSourceModelGlobalNamespace(e){const t=[];return this.metadata.runtime===Runtime.TFJS&&t.push(...getTFJSModelDependencyPackages(e?e.backend:void 0)),t.push(...this.packageUrls),await this.packageLoader.loadPackagesAndGetGlobalNamespace(this.sourceModelGlobalNamespace,t)}async transformSourceModel(e,t){throw new Error("not implemented")}}class ImageClassifier{cleanUp(){}}class ImageClassifierTFLite extends ImageClassifier{constructor(e){super(),this.tfliteImageClassifier=e}async predict(e,t){if(!this.tfliteImageClassifier)throw new Error("source model is not loaded");const s=this.tfliteImageClassifier.classify(e);return s?{classes:s.map(e=>({className:e.className,score:e.probability}))}:{classes:[]}}cleanUp(){if(!this.tfliteImageClassifier)throw new Error("source model is not loaded");this.tfliteImageClassifier.cleanUp()}}class ImageClassificationCustomModelTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"Image classification with TFLite models",description:'An image classfier backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_classifier#model_compatibility_requirements" target:"_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/image-classifier/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageClassifier.create(t.model,t);return new ICCustomModelTFLite(t)}}class ICCustomModelTFLite extends ImageClassifierTFLite{}const imageClassificationCustomModelTfliteLoader=new ImageClassificationCustomModelTFLiteLoader;class MobilenetTFJSLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFJS Mobilenet",description:"Run mobilenet image classification model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/mobilenet"},runtime:Runtime.TFJS,version:"2.1.0",supportedTasks:[Task.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/mobilenet@${this.metadata.version}`]],this.sourceModelGlobalNamespace="mobilenet"}async transformSourceModel(e,t){e=await e.load(t);return new MobilenetTFJS(e,t)}}class MobilenetTFJS extends ImageClassifier{constructor(e,t){super(),this.mobilenetModel=e,this.loadingOptions=t}async predict(e,t){if(!this.mobilenetModel)throw new Error("source model is not loaded");await ensureTFJSBackend(this.loadingOptions);const s=await this.mobilenetModel.classify(e,t?t.topK:void 0);return{classes:s.map(e=>({className:e.className,score:e.probability}))}}}const mobilenetTfjsLoader=new MobilenetTFJSLoader;class MobilenetTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFLite Mobilenet",description:"Run mobilenet image classification model with TFLite",runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.IMAGE_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){let s="1",o="1.0";t&&(void 0!==t.version&&(s=String(t.version)),void 0!==t.alpha&&(o=String(t.alpha))),"2"===s&&"1.0"!==o&&(o="1.0",console.warn(`No mobilenet TFLite model available for ${s}_${o}. Using 2_1.0 instead.`));var a=`https://storage.googleapis.com/tfweb/models/mobilenet_v${s}_${o}_224_1_metadata_1.tflite`,t=await e.ImageClassifier.create(a,t);return new MobilenetTFLite(t)}}class MobilenetTFLite extends ImageClassifierTFLite{}const mobilenetTfliteLoader=new MobilenetTFLiteLoader;class ImageSegmenter{cleanUp(){}}class ImageSegmenterTFLite extends ImageSegmenter{constructor(e){super(),this.tfliteImageSegmenter=e}async predict(e,t){if(!this.tfliteImageSegmenter)throw new Error("source model is not loaded");e=this.tfliteImageSegmenter.segment(e);if(!e)return{legend:{},width:-1,height:-1,segmentationMap:void 0};var s=e[0];const o={},a=[];for(const n of s.coloredLabels)o[n.className||n.displayName]=n,a.push(n);const i=new Uint8ClampedArray(s.width*s.height*4);for(let e=0;e<s.categoryMask.length;e++){var r=s.categoryMask[e],r=a[r];i[4*e]=r.r,i[4*e+1]=r.g,i[4*e+2]=r.b,i[4*e+3]=255}return{legend:o,width:s.width,height:s.height,segmentationMap:i}}cleanUp(){if(!this.tfliteImageSegmenter)throw new Error("source model is not loaded");this.tfliteImageSegmenter.cleanUp()}}class ImageSegmentationCustomModelTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"Image segmentation with TFLite models",description:'An image segmentation backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/image_segmenter#model_compatibility_requirements" target="_blank">model requirements</a>.Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/image-segmenter/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageSegmenter.create(t.model,t);return new ISCustomModelTFLite(t)}}class ISCustomModelTFLite extends ImageSegmenterTFLite{}const imageSegmenterCustomModelTfliteLoader=new ImageSegmentationCustomModelTFLiteLoader;class DeeplapTFJSLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFJS Deeplab",description:"Run deeplab image segmentation model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/deeplab"},runtime:Runtime.TFJS,version:"0.2.1",supportedTasks:[Task.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/deeplab@${this.metadata.version}`]],this.sourceModelGlobalNamespace="deeplab"}async transformSourceModel(e,t){const s=Object.assign({},t)||{backend:"webgl"};null==s.base&&(s.base="pascal"),null==s.quantizationBytes&&(s.quantizationBytes=2);e=await e.load(s);return new DeeplabTFJS(e,s)}}class DeeplabTFJS extends ImageSegmenter{constructor(e,t){super(),this.deeplabModel=e,this.loadingOptions=t}async predict(e,t){if(!this.deeplabModel)throw new Error("source model is not loaded");await ensureTFJSBackend(this.loadingOptions);var s=await this.deeplabModel.segment(e,t);const o={};for(const i of Object.keys(s.legend)){var a=s.legend[i];o[i]={r:a[0],g:a[1],b:a[2]}}return{legend:o,width:s.width,height:s.height,segmentationMap:s.segmentationMap}}cleanUp(){if(!this.deeplabModel)throw new Error("source model is not loaded");this.deeplabModel.dispose()}}const deeplabTfjsLoader=new DeeplapTFJSLoader;class DeeplabTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFLite Deeplab",description:"Run Deeplab image segmentation model with TFLite",runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.IMAGE_SEGMENTATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ImageSegmenter.create("https://tfhub.dev/tensorflow/lite-model/deeplabv3/1/metadata/2?lite-format=tflite",t);return new DeeplabTFLite(t)}}class DeeplabTFLite extends ImageSegmenterTFLite{}const deeplabTfliteLoader=new DeeplabTFLiteLoader;class NLClassifier{cleanUp(){}}class NLClassifierTFLite extends NLClassifier{constructor(e){super(),this.tfliteNLClassifier=e}async predict(e,t){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");const s=this.tfliteNLClassifier.classify(e);return s?{classes:s.map(e=>({className:e.className,score:e.probability}))}:{classes:[]}}cleanUp(){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");this.tfliteNLClassifier.cleanUp()}}function getNLClassifierOptions(e){const t={inputTensorIndex:0,outputScoreTensorIndex:0,outputLabelTensorIndex:-1,inputTensorName:"INPUT",outputScoreTensorName:"OUTPUT_SCORE",outputLabelTensorName:"OUTPUT_LABEL"};return e&&(null!=e.inputTensorIndex&&(t.inputTensorIndex=e.inputTensorIndex),null!=e.outputScoreTensorIndex&&(t.outputScoreTensorIndex=e.outputScoreTensorIndex),null!=e.outputLabelTensorIndex&&(t.outputLabelTensorIndex=e.outputLabelTensorIndex),null!=e.inputTensorName&&(t.inputTensorName=e.inputTensorName),null!=e.outputScoreTensorName&&(t.outputScoreTensorName=e.outputScoreTensorName),null!=e.outputLabelTensorName&&(t.outputLabelTensorName=e.outputLabelTensorName)),t}class NLClassificationCustomModelTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"Natural language classification with TFLite models",description:'A natural language detector backed by the NLClassifier in TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/nl_classifier#model_compatibility_requirements" target="_blank">model requirements</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.NL_CLASSIFICATION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.NLClassifier.create(t.model,getNLClassifierOptions(t));return new NCCustomModelTFLite(t)}}class NCCustomModelTFLite extends NLClassifierTFLite{}const nlClassifierCustomModelTfliteLoader=new NLClassificationCustomModelTFLiteLoader;class ObjectDetector{cleanUp(){}}class CocoSsdTFJSLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFJS COCO-SSD",description:"Run COCO-SSD object detection model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/coco-ssd"},runtime:Runtime.TFJS,version:"2.2.2",supportedTasks:[Task.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/coco-ssd@${this.metadata.version}`]],this.sourceModelGlobalNamespace="cocoSsd"}async transformSourceModel(e,t){e=await e.load(t);return new CocoSsdTFJS(e,t)}}class CocoSsdTFJS extends ObjectDetector{constructor(e,t){super(),this.cocoSsdModel=e,this.loadingOptions=t}async predict(e,t){if(!this.cocoSsdModel)throw new Error("source model is not loaded");await ensureTFJSBackend(this.loadingOptions);const s=await this.cocoSsdModel.detect(e,t?t.maxNumBoxes:void 0,t?t.minScore:void 0);return{objects:s.map(e=>({boundingBox:{originX:e.bbox[0],originY:e.bbox[1],width:e.bbox[2],height:e.bbox[3]},className:e.class,score:e.score}))}}cleanUp(){if(!this.cocoSsdModel)throw new Error("source model is not loaded");return this.cocoSsdModel.dispose()}}const cocoSsdTfjsLoader=new CocoSsdTFJSLoader;class ObjectDetectorTFLite extends ObjectDetector{constructor(e){super(),this.tfliteObjectDetector=e}async predict(e,t){if(!this.tfliteObjectDetector)throw new Error("source model is not loaded");const s=this.tfliteObjectDetector.detect(e);return s?{objects:s.map(e=>({boundingBox:e.boundingBox,className:e.classes[0].className,score:e.classes[0].probability}))}:{objects:[]}}cleanUp(){if(!this.tfliteObjectDetector)throw new Error("source model is not loaded");this.tfliteObjectDetector.cleanUp()}}class CocoSsdTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFLite COCO-SSD",description:"Run COCO-SSD object detection model with TFLite",runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ObjectDetector.create("https://tfhub.dev/tensorflow/lite-model/ssd_mobilenet_v1/1/metadata/2?lite-format=tflite",t);return new CocoSsdTFLite(t)}}class CocoSsdTFLite extends ObjectDetectorTFLite{}const cocoSsdTfliteLoader=new CocoSsdTFLiteLoader;class ObjectDetectionCustomModelTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"Object detection with TFLite models",description:'An object detector backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/object_detector#model_compatibility_requirements" target="_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/object-detector/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.OBJECT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.ObjectDetector.create(t.model,t);return new ODCustomModelTFLite(t)}}class ODCustomModelTFLite extends ObjectDetectorTFLite{}const objectDetectorCustomModelTfliteLoader=new ObjectDetectionCustomModelTFLiteLoader;class QuestionAnswerer{cleanUp(){}}class BertQATFJSLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFJS Bert Q&A model",description:"Run Bert Q&A model with TFJS",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/qna"},runtime:Runtime.TFJS,version:"1.0.0",supportedTasks:[Task.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/qna@${this.metadata.version}`]],this.sourceModelGlobalNamespace="qna"}async transformSourceModel(e,t){let s=null;t&&t.modelUrl&&(s={modelUrl:t.modelUrl}),t&&null!=t.fromTFHub&&s&&(s.fromTFHub=t.fromTFHub);e=await e.load(s);return new BertQATFJS(e,t)}}class BertQATFJS extends QuestionAnswerer{constructor(e,t){super(),this.qnaModel=e,this.loadingOptions=t}async predict(e,t,s){if(!this.qnaModel)throw new Error("source model is not loaded");return await ensureTFJSBackend(this.loadingOptions),{answers:await this.qnaModel.findAnswers(e,t)}}}const bertQaTfjsLoader=new BertQATFJSLoader;class QuestionAnswererTFLite extends QuestionAnswerer{constructor(e){super(),this.tfliteQuestionAnswerer=e}async predict(e,t,s){if(!this.tfliteQuestionAnswerer)throw new Error("source model is not loaded");const o=this.tfliteQuestionAnswerer.answer(t,e);return{answers:o.map(e=>({text:e.text,startIndex:e.pos.start,endIndex:e.pos.end,score:e.pos.logit}))}}cleanUp(){if(!this.tfliteQuestionAnswerer)throw new Error("source model is not loaded");this.tfliteQuestionAnswerer.cleanUp()}}class BertQATFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFLite Bert Q&A model",description:"Run Bert Q&A model with TFLite",runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){e=await e.BertQuestionAnswerer.create("https://tfhub.dev/tensorflow/lite-model/mobilebert/1/metadata/1?lite-format=tflite");return new BertQATFLite(e)}}class BertQATFLite extends QuestionAnswererTFLite{}const bertQaTfliteLoader=new BertQATFLiteLoader;class QuestionAnswerCustomModelTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"Question&Answer with TFLite models",description:'A QuestionAnswerer backed by the TFLite Task Library. It can work with any models that meet the <a href="https://www.tensorflow.org/lite/inference_with_metadata/task_library/bert_question_answerer#model_compatibility_requirements" target="_blank">model requirements</a>. Try models from this <a href="https://tfhub.dev/tensorflow/collections/lite/task-library/bert-question-answerer/1" target="_blank">collection</a>.',resourceUrls:{"TFLite task library":"https://www.tensorflow.org/lite/inference_with_metadata/task_library/overview"},runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.QUESTION_AND_ANSWER]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){t=await e.BertQuestionAnswerer.create(t.model);return new QACustomModelTFLite(t)}}class QACustomModelTFLite extends QuestionAnswererTFLite{}const qaCustomModelTfliteLoader=new QuestionAnswerCustomModelTFLiteLoader;class SentimentDetector{cleanUp(){}}const DEFAULT_THRESHOLD=.5;class MovieReviewTFLiteLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFLite movie review model",description:"Run a movie review model with TFLite and output the probabilities of whether the review is positive or negetive.",runtime:Runtime.TFLITE,version:"0.0.1-alpha.3",supportedTasks:[Task.SENTIMENT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow/tfjs-tflite@${this.metadata.version}/dist/tf-tflite.min.js`]],this.sourceModelGlobalNamespace="tflite"}async transformSourceModel(e,t){e=await e.NLClassifier.create("https://storage.googleapis.com/tfweb/models/movie_review_sentiment_classification.tflite",getNLClassifierOptions()),t=t&&null!=t.threshold?t.threshold:DEFAULT_THRESHOLD;return new MovieReviewTFLite(e,t)}}class MovieReviewTFLite extends SentimentDetector{constructor(e,t){super(),this.tfliteNLClassifier=e,this.threshold=t}async predict(e,t){if(!this.tfliteNLClassifier)throw new Error("source model is not loaded");var s=this.tfliteNLClassifier.classify(e);if(!s)return{sentimentLabels:{}};e=s[0].probability,s=s[1].probability;let o=null,a=null;return Math.max(e,s)>this.threshold&&(o=e<s,a=s<e),{sentimentLabels:{positive:{result:o,probabilities:[e,s]},negative:{result:a,probabilities:[s,e]}}}}}const movieReviewTfliteLoader=new MovieReviewTFLiteLoader;class ToxicityTFJSLoader extends TaskModelLoader{constructor(){super(...arguments),this.metadata={name:"TFJS Toxicity model",description:"Detect whether text contains toxic content such as threatening language, insults, obscenities, identity-based hate, or sexually explicit language.",resourceUrls:{github:"https://github.com/tensorflow/tfjs-models/tree/master/toxicity"},runtime:Runtime.TFJS,version:"1.2.2",supportedTasks:[Task.SENTIMENT_DETECTION]},this.packageUrls=[[`https://cdn.jsdelivr.net/npm/@tensorflow-models/toxicity@${this.metadata.version}`]],this.sourceModelGlobalNamespace="toxicity"}async transformSourceModel(e,t){e=await e.load(t&&t.threshold?t.threshold:.85,t&&t.toxicityLabels?t.toxicityLabels:[]);return new ToxicityTFJS(e,t)}}class ToxicityTFJS extends SentimentDetector{constructor(e,t){super(),this.toxicityModel=e,this.loadingOptions=t}async predict(e,t){if(!this.toxicityModel)throw new Error("source model is not loaded");await ensureTFJSBackend(this.loadingOptions);const s={};for(const o of await this.toxicityModel.classify(e))s[o.label]={result:o.results[0].match,probabilities:Array.from(o.results[0].probabilities)};return{sentimentLabels:s}}}const toxicityTfjsLoader=new ToxicityTFJSLoader,modelIndex={[Task.IMAGE_CLASSIFICATION]:{MobileNet:{[Runtime.TFJS]:mobilenetTfjsLoader,[Runtime.TFLITE]:mobilenetTfliteLoader},CustomModel:{[Runtime.TFLITE]:imageClassificationCustomModelTfliteLoader}},[Task.OBJECT_DETECTION]:{CocoSsd:{[Runtime.TFJS]:cocoSsdTfjsLoader,[Runtime.TFLITE]:cocoSsdTfliteLoader},CustomModel:{[Runtime.TFLITE]:objectDetectorCustomModelTfliteLoader}},[Task.IMAGE_SEGMENTATION]:{Deeplab:{[Runtime.TFJS]:deeplabTfjsLoader,[Runtime.TFLITE]:deeplabTfliteLoader},CustomModel:{[Runtime.TFLITE]:imageSegmenterCustomModelTfliteLoader}},[Task.SENTIMENT_DETECTION]:{MovieReview:{[Runtime.TFLITE]:movieReviewTfliteLoader},Toxicity:{[Runtime.TFJS]:toxicityTfjsLoader}},[Task.NL_CLASSIFICATION]:{CustomModel:{[Runtime.TFLITE]:nlClassifierCustomModelTfliteLoader}},[Task.QUESTION_AND_ANSWER]:{BertQA:{[Runtime.TFJS]:bertQaTfjsLoader,[Runtime.TFLITE]:bertQaTfliteLoader},CustomModel:{[Runtime.TFLITE]:qaCustomModelTfliteLoader}}},ImageClassification=modelIndex[Task.IMAGE_CLASSIFICATION],ObjectDetection=modelIndex[Task.OBJECT_DETECTION],ImageSegmentation=modelIndex[Task.IMAGE_SEGMENTATION],SentimentDetection=modelIndex[Task.SENTIMENT_DETECTION],NLClassification=modelIndex[Task.NL_CLASSIFICATION],QuestionAndAnswer=modelIndex[Task.QUESTION_AND_ANSWER];function getModelLoadersByRuntime(t){return filterModelLoaders(e=>t.includes(e.metadata.runtime))}function getAllModelLoaders(){const e=[];for(const a of Object.keys(modelIndex)){var t=modelIndex[a];for(const i of Object.keys(t)){var s=t[i];for(const r of Object.keys(s)){var o=s[r];e.push(o)}}}return e}function filterModelLoaders(e){const t=[];for(const s of getAllModelLoaders())e(s)&&t.push(s);return t}const version="0.0.1-alpha.8";export{ICCustomModelTFLite,ImageClassification,ImageClassificationCustomModelTFLiteLoader,ImageSegmentation,MobilenetTFJS,MobilenetTFJSLoader,MobilenetTFLite,MobilenetTFLiteLoader,NLClassification,ObjectDetection,QuestionAndAnswer,SentimentDetection,TaskModelLoader,getAllModelLoaders,getModelLoadersByRuntime,imageClassificationCustomModelTfliteLoader,mobilenetTfjsLoader,mobilenetTfliteLoader,version};
//# sourceMappingURL=tfjs-tasks.fesm.min.js.map
